package org.osmf.net.httpstreaming
{
	import flash.events.Event;
	import flash.events.EventDispatcher;
	import flash.events.IEventDispatcher;
	import flash.events.NetStatusEvent;
	import flash.events.TimerEvent;
	import flash.net.FileReference;
	import flash.net.NetConnection;
	import flash.net.NetStream;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.URLStream;
	import flash.net.URLVariables;
	import flash.utils.Dictionary;
	import flash.utils.Timer;
	import flash.utils.getTimer;
	
	import flashx.textLayout.formats.Float;
	
	import mx.charts.AreaChart;
	import mx.collections.ArrayCollection;
	import mx.collections.ICollectionView;
	import mx.core.INavigatorContent;
	import mx.messaging.channels.StreamingAMFChannel;
	import mx.utils.OrderedObject;
	
	import org.osmf.events.HTTPStreamingEvent;
	import org.osmf.events.MediaPlayerCapabilityChangeEvent;
	import org.osmf.events.SeekEvent;
	import org.osmf.events.TimeEvent;
	import org.osmf.logging.Logger;
	import org.osmf.media.*;
	import org.osmf.media.MediaResourceBase;
	import org.osmf.net.httpstreaming.*;
	import org.osmf.net.httpstreaming.DefaultHTTPStreamingSwitchManager;
	import org.osmf.net.httpstreaming.HTTPNetStream;
	import org.osmf.net.httpstreaming.HTTPStreamDownloader;
	import org.osmf.net.httpstreaming.HTTPStreamSource;
	import org.osmf.net.httpstreaming.HTTPStreamingNetLoader;
	import org.osmf.net.qos.QoSInfo;
	import org.osmf.traits.SeekTrait;
	import org.osmf.utils.OSMFSettings;
	
	
	[Event(name="downloadComplete", type="org.osmf.events.HTTPStreamingEvent")]
	
	[Event(name="DVRStreamInfo", type="org.osmf.events.DVRStreamInfoEvent")]
	
	[Event(name="runAlgorithm", type="org.osmf.events.HTTPStreamingEvent")]
	
	[Event(name="qosUpdate", type="org.osmf.events.QoSInfoEvent")] 
	
	[Event(name="showAlert", type="flash.events.Event")]
	
	[Event(name="closeAlert", type="flash.events.Event")]
	
	
	public class HTTPDownloadManager extends EventDispatcher
	{
		public var netstream_buffer:Number=0;
		public var prev_videoid:int=0;
		private var dummyid:int=0;
		public var videoid:int=0;
		public var completedvideoid:Array=new Array;
		public var completedONEvideoid:Array=new Array;
		public var videoid_alt:int=0;
		public var deadlines:Array=[20,40,60,80,100,120];
		public var pref_array:Array=[1,2];
		public var positions:Array=[1,2,3,4,5,6];
		private var lastStream:int=0;
		public var alt_array:Array=[3,4];
		public var advert:Boolean=false;
		private var off_duration:Number=0
		private var DesiredMax:int=0;
		private var qSwitcher:Boolean=false;
		private var DesiredMin:int=1;
		private var bundleList:Array=[1,2,3,4,5,6];
		public var currentStream:int=0;
		public var pastStream:int=0;
		private var storedtime:int=0;
		private var seeking:Boolean=false;
		private var to_move:int=0;
		public var downloader_rate:Number=0;
		private var missed_stream:Array=new Array;
		private var missed_fragments:Array=new Array;
		private var admissed_fragments:Array=new Array;
		private var missed_quality:Array=new Array;
		private var admissed_quality:Array=new Array;
		private var admissed_id:Array=new Array;
		private var match_array:Array= new Array;
		private var match_array_alt1:Array= [1,2,3,4,5,6];
		private var match_array_alt2:Array= [6,7,8,9,10,11];
		private var match_array_alt3:Array= [11,12,13,14,15,16];
		private var match_array_alt4:Array= [16,17,18,19,20,21];
		private var match_array_alt5:Array= [21,22,23,24,25,26];
		private var bMain:Number=0;
		private var bPrefetch:Number=0;
		private var branchArray:Array=new Array;
		private var possibles_connection:Array=new Array;
		private var possibles_quality:Array=new Array;
		public var normal_running:uint = 0;
		private var qmax_saveq:int=0;
		private var qmax_savec:int=0;
		public var delta:int=0;
		private var firsttime:int=0;
		private var par_complete:Boolean=false;
		private var blocker1:Boolean = false;
		private var blocker:Boolean = false;
		private var next_dec:int=0;
		private var parallel_frag:Array = new Array;
		private var parallel_pending:Boolean=false;
		private var adparallel_pending:Boolean=false;
		private var parallel_quality:Array = new Array;
		private var to_downloadlist:Array=new Array;
		private var to_downloadlistRR:Array=new Array;
		private var missedEarlier:Boolean=false;
		private var missedEarlierList:Array=new Array;
		private var ad_downloadlist:Array=new Array;
		private var downloadorder:Array=new Array;
		private var listindex:int=0;
		private var to_qualitylist:Array=new Array;
		public var quality_array:Array = [250,500,850,1300];
		public var fragmentQ:Dictionary=new Dictionary;
		public var downloadedlist:Array=new Array;
		public var prefdownloadedlist:Array=new Array;
		private var downloadedlist_0:Array=new Array;
		private var downloadedlist_1:Array=new Array;
		private var downloadedlist_2:Array=new Array;
		private var downloadedlist_3:Array=new Array;
		private var downloadedlist_4:Array=new Array;
		private var downloadedlist_5:Array=new Array;
		private var downloadedlist_6:Array=new Array;
		
		private var qualitylist:Array=new Array;
		private var qualitylist_0:Array=new Array;
		private var qualitylist_1:Array=new Array;
		private var qualitylist_2:Array=new Array;
		private var qualitylist_3:Array=new Array;
		private var qualitylist_4:Array=new Array;
		private var qualitylist_5:Array=new Array;
		private var qualitylist_6:Array=new Array;
		
		public var modicaPrefetchica:String="zipf";
		
		private var lastFrag:int;
		private var justSwitched:Boolean=false;
		private var missingStuff:Array=new Array;
		private var prev_dloadlist:int=0;
		private var last_downloadrate:Number=0;

		public var addownloadedlist:Dictionary = new Dictionary();
		public var adarray:Array=new Array;
		public var adID:int=0;
		public var adqualitylist:Array=new Array;
		public var streamdownloadedlist:Array=new Array;
		public var resumedownloadlist:Array=new Array;
		public var stream_downloaded:int = 0;
		private var deadprefetchunblock:Boolean=false;
		private var workahead:int = 0;
		public var streamwaiting_index:Array=new Array;
		public var streamwaiting_quality:Array=new Array;
		private var maxinParallel:int=0;
		public var alpha:Number = 0;
		public var prevMediaPlayer:MediaPlayer;
		public var mode:String="";
		public var scenario:String="";

		private var orderedlist:Array=["8.2","8.1","7.2","7.1","6.2","6.1","5.2","5.1","4.2","4.1","3.2","3.1","2.2","2.1","1.2","1.1","0.2","0.1"];
		private var orderedextralist:Array=["0.3","0.4","1.3","1.4","2.3","2.4","3.3","3.4","4.3","4.4","5.3","5.4","6.3","6.4","7.3","7.4","8.3","8.4"];
		private var entered:Boolean=true;
		private var prefetching:String="";
		private var portedChoices:Array=new Array;
		private var prefetchmode:String="";
		private var prefetchpolicy:String="";
		private var whatbased:String="";
		private var filler:String="";
		private var addeadline:String="";
		private var tmin_bundle:int=0;
		private var tmax_bundle:int=0;
		public var downloadBlocker:Boolean=true;
		public var prefetchStream:int=0;

		private var buf_min:int=0;
		public var vid_indexer:int=2;
		public var magicunblocker:Boolean=false;
		private var buf_margin:int=0;
		private var minus_calc:int=0;
		public var global_avg:Number = 0;
		public var twochunk_avg:Number = 0;
		public var current_est:Number = 0;
		private var onetwocomplete:Boolean=false;
		private var parallelpipe_on:Boolean = false;
		
		public var Buffer:Number=0;
		private var Buffer_0:Number=0;
		private var Buffer_1:Number=0;
		private var Buffer_2:Number=0;
		private var Buffer_3:Number=0;
		private var Buffer_4:Number=0;
		private var Buffer_5:Number=0;
		private var Buffer_6:Number=0;
		
		private var QHolder:Array=new Array;
		private var QHolder_0:Array=new Array;
		private var QHolder_1:Array=new Array;
		private var QHolder_2:Array=new Array;
		private var QHolder_3:Array=new Array;
		private var QHolder_4:Array=new Array;
		private var QHolder_5:Array=new Array;
		private var QHolder_6:Array=new Array;
		
		private var avgQ_0:Number=0;
		private var avgQ_1:Number=0;
		private var avgQ_2:Number=0;
		private var avgQ_3:Number=0;
		private var avgQ_4:Number=0;
		private var avgQ_5:Number=0;
		private var avgQ_6:Number=0;
		
		public var BufferHolder:Array=new Array;
		private var BufferHolder_0:Array=new Array;
		private var BufferHolder_1:Array=new Array;
		private var BufferHolder_2:Array=new Array;
		private var BufferHolder_3:Array=new Array;
		private var BufferHolder_4:Array=new Array;
		private var BufferHolder_5:Array=new Array;
		private var BufferHolder_6:Array=new Array;
		
		private var ratiocounter:Number=0;
		public var adpipe_on:Boolean = false;
		private var adpipe_parallel_on:Boolean = false;
		private var parallelpipeexc_on:Boolean = false;
		private var parallelpipe_on_alt:Boolean = false;
		private var parallelpipe_on_alt1:Boolean = false;
		static private var instance:HTTPDownloadManager = null;
		private var dloadTimerbegin1:Number = 0;
		private var dloadTimerend1:Number = 0;
		private var dloadTimerbeginest:Number = 0;
		private var addloadTimerbeginest:Number = 0;
		private var dloadTimerendest:Number = 0;
		private var addloadTimerendest:Number = 0;
		private var dloadTimerbeginest_exc:Number = 0;
		private var dloadTimerendest_exc:Number = 0;
		private var dloadTimerbeginest_alt:Number = 0;
		private var dloadTimerbeginest_alt1:Number = 0;
		private var dloadTimerendest_alt:Number = 0;
		private var dloadTimerendest_alt1:Number = 0;
		private var BufferStatus:String="download";
		private var previouslyLogged:String="download";
		private var dloadTimerbegin2:Number = 0;
		private var dloadTimerend2:Number = 0;
		private var dloadTimerbegin3:Number = 0;
		private var dloadTimerend3:Number = 0;
		private var dloadTimerbegin4:Number = 0;
		private var dloadTimerend4:Number = 0;
		private var prefQ1:Number = 0;
		private var prefQ2:Number = 0;
		private var prefQ3:Number = 0;
		private var prefQ4:Number = 0;
		private var prefestF1:Number = 0;
		private var adprefestF1:Number = 0;
		private var prefestQ1:Number = 0;
		private var adprefestQ1:Number = 0;
		private var prevfrag:int=0;
		private var prefestF1_exc:Number = 0;
		private var prefestQ1_exc:Number = 0;
		private var prefestF1_alt:Number = 0;
		private var prefestQ1_alt:Number = 0;
		private var prefestF1_alt1:Number = 0;
		private var prefestQ1_alt1:Number = 0;
		private var prefF1:Number = 0;
		private var prefF2:Number = 0;
		private var prefF3:Number = 0;
		private var prefF4:Number = 0;
		private var request:URLRequest;
		private var loader:URLLoader;
		private var loader1:URLLoader;
		private var request1:URLRequest;
		private var request2:URLRequest;
		private var loader2:URLLoader;
		private var request3:URLRequest;
		private var request4:URLRequest;
		private var request5:URLRequest;
		private var loader3:URLLoader;
		private var loader4:URLLoader;
		private var loader5:URLLoader;
		private var streamingEvent:HTTPStreamingEvent;
		private static const logger:org.osmf.logging.Logger = org.osmf.logging.Log.getLogger("org.osmf.net.httpstreaming.HTTPDownloadManager");
		private var fileContent:String;
		private var fileContent1:String;
		private var fileContent2:String;
		private var fileContent3:String;
		private var fileContent4:String;
		private var fileContent5:String;
		public var jumpTime:Array=new Array;
		public var pushButton:Array=new Array;		
		public var frag_deadline:Array=new Array;
		public var decPoints:Vector.<Number> = new Vector.<Number>;
		public var landPoints:Vector.<Number> = new Vector.<Number>;
		public var firstlandPoints:Vector.<Number> = new Vector.<Number>;
		public var nolandPoints:Vector.<Number> = new Vector.<Number>;

		public var fragments:Dictionary = new Dictionary();		// Vectorer containing several fragments downloaded before hand, these are the fragments we "land" on after a jump
		public var adfragments:Dictionary = new Dictionary();		// Vectorer containing several fragments downloaded before hand, these are the fragments we "land" on after a jump
		public var time_download:Dictionary = new Dictionary();
		public var quality_download:Dictionary = new Dictionary();
		public var fragmentsquality:Dictionary = new Dictionary();		
		private var prefetchPath:Array = new Array;
		private var AltprefetchPath:Array = new Array;
		private var branch_prefetchPath:Array = new Array;
		private var branch_Path:Array = new Array;
		private var branch_prefetchPathShifted:Array = new Array;
		private var treeStructure:String;
		private var message:String = "My very own message!";
		private var messages:Vector.<String> = new Vector.<String>;
		private var branchLengths:Vector.<Number> = new Vector.<Number>;
		private var branchLeft:Boolean = true;					// Currently branching left is following the default route through the video
		private var branchNum:uint = 0;
		private var lastChecked:Number = 0;
		private var currentFrag:Number = -1;
		private static var netStream2:HTTPNetStream;

		private var checkCounter:int = 0;
		private var jumpCount:int = 0;

		public var timePass:int = 0;
		public var minus:int = 0;

		public var previousCounter:uint = 0;
		public var anotherpreviousCounter:uint = 0;
		public var availablepaths:Array = new Array;
		private var numberinParallel:int=1;
		public var all_jump_paths:Array = new Array;
		public var playerpath:String = "";
		public var extrapolatedplayerpath:String = "";
		public var playerpath_alt:String = "";
		public var futurepath:String = "";
		private var anotherdummy:String;
		public var lastfragment:String = "";
		public var lastquality:String = "";
		private var prevFrag:String = "";
		public var landNumber:uint = 0;
		public var jump_array:Array = new Array;
		private static var netStream1:HTTPNetStream;
		private var qualityinbytes:uint = 0;
		private var exportbranchNum:int = 0;
		private var receivedCount:Number = 0;
		private var secBranchnum:uint = 0;
		private var donePath:Array = new Array;
		public var donot_add:uint = 0;
		private var lastpath:String = "";
		private var playpath1:String = "";
		private var setpath:String = "";
		private var x:uint = 0;
		private var subtract:uint = 0;
		private var carryfragnum:uint = 0;
		private var prefetchingquality:Number=0;
		private var split:Array = new Array;
		public var runtable:Array = new Array; 
		public var estimate:uint = 0;
		public var fragRate:uint = 0;
		public var alt_set:Boolean = false;
		private var netstreamblock:Boolean=false;
		
		private var masterSizeList:Object = new Object();
		public var sizearray_250:Array = new Array;
		public var sizearray_500:Array = new Array;
		public var sizearray_850:Array = new Array;
		public var sizearray_1300:Array = new Array;
		private var reach_max_in:Number=0;
		private var triBoolean:Object = null;
		public var willplayAD:Object=null;
		private var complete:Boolean=false;
		public var streamdownloadedAD:Array=new Array;
		private var tokenQ:Array=new Array;
		private var tokenNum:Array=new Array;
		private var downloadedtokenNum:Array=new Array
		private var alternatetokenNum:Array=new Array
		private var tokenFrag:Array=new Array;
		private var tokenId:Array=new Array;
		private var preventertokenId:Array=new Array;
		private var preventertokenNum:Array=new Array;
		private var preventertokenQ:Array=new Array;
		private var downloadedtokenId:Array=new Array;
		private var alternatetokenId:Array=new Array;
		
		CONFIG::LOGGING
		{
			private var numBytes:Number = 0;
			private var doneOnce:Boolean = false;
		}
		
		// Emulates a singleton
		static public function getInstance():HTTPDownloadManager
		{
			if(instance == null)
				instance = new HTTPDownloadManager();
			return instance;
		}
		
		
		static public function passNetstream(netStream_passed:HTTPNetStream):void
		{
			netStream1=netStream_passed;
		}
		
		static public function createcopy():void
		{
			netStream2=netStream1;
		}
		
		static public function giveNS():HTTPNetStream
		{
			return netStream1;
		}
		
		public function getfragcount(count:Number):void
		{
			receivedCount = count
		}
		
		public function passTime():int
		{
			return netStream1.time;
		}
		
		// Turns out AS doesn't support anything but public constructors!
		public function HTTPDownloadManager()
		{
			request = new URLRequest("test.txt");		// This is the text file we are reading the tree structure from, needs a better URL for real testing
			loader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, processFile); // We cannot garantee the program will let us load the text file first, so we will signal when it is ready for processing
			try
			{
				loader.load(request);
			}
			catch(error:Error)
			{
				trace("Some error occured1: " + error.message);
			}
			
			masterSizeList["11"] = ["1240","2008","3576","5496"];
			masterSizeList["16"] = ["1488","3112","4632","5640"];
			masterSizeList["21"] = ["728","1072","1568","2488"];
			masterSizeList["26"] = ["1688","2792","5184","5808"];
			masterSizeList["31"] = ["1520","2400","3376","5072"];
			masterSizeList["36"] = ["1440","2360","3608","5432"];
			
			request1 = new URLRequest("input.txt");		// This is the text file we are reading the tree structure from, needs a better URL for real testing
			loader1 = new URLLoader();
			loader1.addEventListener(Event.COMPLETE, processInputFile); // We cannot garantee the program will let us load the text file first, so we will signal when it is ready for processing
			try
			{
				loader1.load(request1);
			}
			catch(error:Error)
			{
				trace("Some error occured2: " + error.message);
			}
			var myTimer1:Timer = new Timer(50, 0); // 1 second
			myTimer1.addEventListener(TimerEvent.TIMER, onCanSeekChange1);
			myTimer1.start();
			
			var myTimer3:Timer = new Timer(250, 0); // 1 second
			myTimer3.addEventListener(TimerEvent.TIMER, dummy);
			myTimer3.start();
			
			
			var myTimer2:Timer = new Timer(1000, 0); // 1 second
			myTimer2.addEventListener(TimerEvent.TIMER, displaytime);
			myTimer2.start();
			
			request2 = new URLRequest("input1.txt");		// This is the text file we are reading the tree structure from, needs a better URL for real testing
			loader2 = new URLLoader();
			loader2.addEventListener(Event.COMPLETE, processInputFile1); // We cannot garantee the program will let us load the text file first, so we will signal when it is ready for processing
			try
			{
				loader2.load(request2);
			}
			catch(error:Error)
			{
				trace("Some error occured3: " + error.message);
			}
			
			request3 = new URLRequest("pathfile.txt");		// This is the text file we are reading the tree structure from, needs a better URL for real testing
			loader3 = new URLLoader();
			loader3.addEventListener(Event.COMPLETE, processpathFile); // We cannot garantee the program will let us load the text file first, so we will signal when it is ready for processing
			try
			{
				loader3.load(request3);
			}
			catch(error:Error)
			{
				trace("Some error occured4: " + error.message);
			}
			
			request4 = new URLRequest("workahead.txt");		// This is the text file we are reading the tree structure from, needs a better URL for real testing
			loader4 = new URLLoader();
			loader4.addEventListener(Event.COMPLETE, processInputFile2); // We cannot garantee the program will let us load the text file first, so we will signal when it is ready for processing
			try
			{
				loader4.load(request4);
			}
			catch(error:Error)
			{
				trace("Some error occured5: " + error.message);
			}
			//			
			request5 = new URLRequest("automator.txt");		// This is the text file we are reading the tree structure from, needs a better URL for real testing
			loader5 = new URLLoader();
			loader5.addEventListener(Event.COMPLETE, processAutomatorFile); // We cannot garantee the program will let us load the text file first, so we will signal when it is ready for processing
			try
			{
				loader5.load(request5);
			}
			catch(error:Error)
			{
				trace("Some error occured6: " + error.message);
			}
			
			for (var z:uint=1;z<=4;z++){
				for(var n:uint=0;n<3;n++){
					downloadorder.push(z);
				}
			}
			var myTimer10:Timer = new Timer(1000, 0); // 1 second
			myTimer10.addEventListener(TimerEvent.TIMER, decreaseBuffer);
			myTimer10.start();
			
			if(orderedextralist.length>0){
				for(var t:uint=0;t<orderedextralist.length;t++){
					alternatetokenNum.push(transforminputs(orderedextralist[t],2));
					alternatetokenId.push(transforminputs(orderedextralist[t],1));
				}
			}
		}
		
	
		public function receivedelta(value:int):void
		{
			if(whatbased=="token"){
				//				TOKENS GEN AT 0
				var myTimer1:Timer = new Timer(0, 1); // 1 second
				myTimer1.addEventListener(TimerEvent.TIMER, generate_tokens);
				myTimer1.start();
				
				//				subsequent token gens
				delta=value;
				var time:int=int((delta)*1000);
				var myTimer:Timer = new Timer(time, 0); // 1 second
				myTimer.addEventListener(TimerEvent.TIMER, generate_tokens);
				myTimer.start();
			}
		}
		
		private function pathcheck(number:uint):Boolean
		{
			for(var i:uint=0;i<split.length;i++){
				if(number == int(split[i]))
					return true;
			}
			return false;
		}
		
		public function avg_passer():Number
		{
			if(global_avg!=0)
				return global_avg;
			return 0;
		}
		
		private function processpathFile(event:Event):void
		{
			var loader:URLLoader = URLLoader(event.target);
			fileContent3 = loader.data;
			
			var startTree:Number = fileContent3.indexOf("begin ");
			var endTree:Number = fileContent3.indexOf("end\r\n", startTree);
			var tempStr:String = fileContent3.substring(startTree+6, endTree);
			split = tempStr.split("\r\n");
			logger.debug("path file "+ split);
			//			REMOVE THIS BIT FOR NO PREFETCHING
			if(split[0]==""){
				for(var j:uint=0; j<70;j++){
					split[j]=j;
				}
			}
			
		}
		
		public function checkprefetchpath(num:uint):Boolean
		{
			logger.debug("checked for "+num);
			for(var y:uint=0;y<AltprefetchPath.length;y++){
				if(num == AltprefetchPath[y]){
					return true;
				}
			}
			return false;
		}
		
		private function processInputFile1(event:Event):void
		{
			var loader:URLLoader = URLLoader(event.target);
			fileContent2 = loader.data;
			logger.debug("Input file2 "+ fileContent2);
		}
		
		private function processAutomatorFile(event:Event):void
		{
			var loader:URLLoader = URLLoader(event.target);
			fileContent5 = loader.data;
			logger.debug("Automator data "+ fileContent5);
			var tempStr:Array = fileContent5.split("\r\n");
			for(var i:uint=0;i<tempStr.length;i++){
				var temp:Array=tempStr[i].split(" ");
				jumpTime.push(temp[0]);
				pushButton.push(temp[1])
			}
			
		}
		
		private function processInputFile2(event:Event):void
		{
			var loader:URLLoader = URLLoader(event.target);
			fileContent4 = loader.data;
			logger.debug("Input file3 "+ fileContent4);
			var tempStr:Array = fileContent4.split("\r\n");
			var start1:Number = tempStr[0].indexOf(":");
			var start2:Number = tempStr[1].indexOf(":");
			var start3:Number = tempStr[2].indexOf(":");
			var start4:Number = tempStr[3].indexOf(":");
			var start5:Number = tempStr[4].indexOf(":");
			var start6:Number = tempStr[5].indexOf(":");
			var start7:Number = tempStr[6].indexOf(":");
			var start8:Number = tempStr[7].indexOf(":");
			var start9:Number = tempStr[8].indexOf(":");
			var start10:Number = tempStr[9].indexOf(":");
			var start11:Number = tempStr[10].indexOf(":");
			var start12:Number = tempStr[11].indexOf(":");
			var start13:Number = tempStr[12].indexOf(":");
			var start14:Number = tempStr[13].indexOf(":");
			var start15:Number = tempStr[14].indexOf(":");
			workahead= tempStr[0].substring((start1 + 1));
			maxinParallel= tempStr[1].substring((start2 + 1));
			alpha= tempStr[2].substring((start3 + 1));
			mode= tempStr[3].substring((start4+2));
			buf_min = tempStr[4].substring((start5+2));
			buf_margin= tempStr[5].substring((start6+2));
			scenario= tempStr[6].substring((start7+2));
			prefetching= tempStr[7].substring((start8+2));
			prefetchmode= tempStr[8].substring((start9+2));
			prefetchpolicy= tempStr[9].substring((start10+2));
			whatbased= tempStr[10].substring((start11+2));
			filler= tempStr[11].substring((start12+2));
			addeadline= tempStr[12].substring((start13+2));
			tmin_bundle= tempStr[13].substring((start14+2));
			tmax_bundle= tempStr[14].substring((start15+2));
		
		}
		
		private function processInputFile(event:Event):void
		{
			var loader:URLLoader = URLLoader(event.target);
			fileContent1 = loader.data;
			logger.debug("Input file "+ fileContent1);
		}
		
		
		public function returnBranch():uint
		{
			logger.debug("branchnumber "+secBranchnum);
			return secBranchnum;
		}
		
		public function setsecbranchnum():void
		{
			secBranchnum = 0;
			return;
		}
		
		public function setBranch(val:uint):void
		{
			branchNum = val;
			secBranchnum = val;
			logger.debug("branchnumber return branch "+secBranchnum);
		}
		

		public function returnBranchnum():int{
			return exportbranchNum;
		}
		
		public function onCanSeekChange(event:TimerEvent):void {//( seekTo : MediaPlayerCapabilityChangeEvent ):void {
			if (branchNum != 0 && compareFraginSec(netStream1.time) && jump_array[branchNum-1] != null)//netStream1.time >= 16)
			{				
				for(var index:uint=0; index < availablepaths.length; index++){
					logger.debug("check outside " + availablepaths[index] + " " + playerpath+ " "+ playpath1);
					if( playerpath == availablepaths[index]){// || oneminusPath == availablepaths[index] && playerpathindonepath(oneminusPath) == true){
						donePath[x] = playerpath;
						logger.debug("another seek "+ donePath[x]);
						x++;
						var jumpfrag:int = index;
	
						logger.debug("check "+ (((jump_array[branchNum-1])*4)-4));
			
						netStream1.seek(((jump_array[branchNum-1])*4)-4);								//ORIGINALLY 3
						//						branchLeft = true;																//WORKS FOR 2 BRANCHES
						exportbranchNum = branchNum;
						branchNum = 0;
						checkCounter = 0;
						lastpath = playerpath;
					}
				}			
			}
			else{
				
				CONFIG::LOGGING
				{
					logger.debug("branchleft no seek");
					//					logger.debug("branchleft hela landpoint arrayen: " + branchLeft + " " + compareFraginSec(netStream1.time));
				}
			}
		}
		

		public function onCanSeekChange1(event:TimerEvent):void {//( seekTo : MediaPlayerCapabilityChangeEvent ):void {
			try
			{
				timePass = netStream1.time;
				if(timePass==0){
					netStream1=netStream2;
				}
			}
			catch(error:Error)
			{
				trace("Some error occured7: " + error.message);
				logger.debug("something went wrong here");
			}
			
			if (branchNum != 0 && jump_array[branchNum-1] != null && checkavail(playerpath) == true){
				//			if (checkavail(playerpath) == true){
				if(compareFraginSec(netStream1.time) == false){
					//					logger.debug("another seek "+ branchNum+ " "+jump_array[branchNum-1] + " "+ setpath);
					setpath = playerpath;
					//					return false;
				}
			}
			
			if (branchNum != 0 && jump_array[branchNum-1] != null && checkavail(setpath) == true && checkdonepath(setpath) == false){
				if(compareFraginSec(netStream1.time) == true ){
					seeking=true;					
					var a:Number = ((jump_array[branchNum-1])*4)-3;
					a=a+0.5;
					donot_add = Math.round(a/4);
					bufferTimeChangeStart(0.5);
					netStream1.seek(a);
					playerpath_adhoc(a);
					donePath[x] = setpath;
					x++;
					logger.debug("another seek afterseek "+ branchNum+ " "+a + " "+ setpath+ " "+netStream1.bufferLength);
					exportbranchNum = branchNum;
					branchNum = 0;
					checkCounter = 0;
					playerpath = setpath;
					branch_prefetchPath = new Array;
					branch_prefetchPathShifted = new Array;
					firsttime=0;
					seeking=false;
					Buffer=0;
				}
			}		
			else{
				
				//				CONFIG::LOGGING
				//				{
				//					logger.debug("branchleft no seek");
				//					//					logger.debug("branchleft hela landpoint arrayen: " + branchLeft + " " + compareFraginSec(netStream1.time));
				//				}
			}
		}
		
		//		public function printbuffer():void
		//		{
		//			netStream1.timeprint();
		//		}
		//		private function complete(event:Event):void
		//		{
		//			par_complete = true;
		//		}
		
		private function playerpath_adhoc(num:Number):void
		{
			var hold:String = (Math.round(num/4)).toString();
			var concatdummy:String = " ";		
			var concattemp:String = concatdummy.concat(hold);
			playerpath = playerpath.concat(concattemp);
		}
		
		private function bufferTimeChangeStart(newTime:Number):void
		{
			netStream1.bufferTime = newTime;
			var myTimer1:Timer = new Timer(4000, 1); 
			myTimer1.addEventListener(TimerEvent.TIMER, resetbufferTime);
			myTimer1.start();
		}
		
		private function resetbufferTime(event:TimerEvent):void
		{
			netStream1.bufferTime = 4;
		}
		
		public function displaytime(event:TimerEvent):void
		{
			try
			{
				var tid:Number=Math.floor(netStream1.time);
				if(prevMediaPlayer!=null){
					tid=Math.floor(prevMediaPlayer.currentTime);
				}else if(prevMediaPlayer==null){
					tid=Math.floor(netStream1.time);
				}
				logger.debug("current time "+tid);
			}
			catch(error:Error)
			{
			}
		}
		
		//		public function decreaseBuffer(frag:Number):void
		public function decreaseBuffer(event:TimerEvent):void
		{
			Buffer=choseBuffer(currentStream);
			if(advert!=true && Buffer>=1){
				Buffer=Buffer-1;
				setBuffer(Buffer,currentStream);
				logger.debug("BUFFER SIZE IS "+Buffer+" "+currentStream+" "+BufferStatus);
				var fragIndex:int=Math.round(getTimetoSeek()/4);
				if(fragIndex>0){
					for(var j:int=0;j<=6;j++){
						BufferHolder=choseBufferHolder(j);
						for(var i:int=0;i<BufferHolder.length;i++){
							if(fragIndex>=BufferHolder[i]){
								BufferHolder.splice(i,i+1)
								i--;
							}
						}
						setBufferHolder(BufferHolder,j);
					}
					
					for(var m:int=0;m<=6;m++){
						QHolder=choseQHolder(m);
						for(var n:int=0;n<QHolder.length;n++){
							if(fragIndex>n){
								QHolder[n]=0;						
							}
						}
						setQHolder(QHolder,m);
					}
					recomputeQ();
					
					recomputeBuffer(fragIndex,0);
					recomputeBuffer(fragIndex,1);
					recomputeBuffer(fragIndex,2);
					recomputeBuffer(fragIndex,3);
					recomputeBuffer(fragIndex,4);
					recomputeBuffer(fragIndex,5);
					recomputeBuffer(fragIndex,6);
					logger.debug("BUFFER size Stream 0 "+Buffer_0+" "+fragIndex);
					logger.debug("BUFFER size Stream 1 "+Buffer_1+" "+fragIndex);
					logger.debug("BUFFER size Stream 2 "+Buffer_2+" "+fragIndex);
					logger.debug("BUFFER size Stream 3 "+Buffer_3+" "+fragIndex);
					logger.debug("BUFFER size Stream 4 "+Buffer_4+" "+fragIndex);
					logger.debug("BUFFER size Stream 5 "+Buffer_5+" "+fragIndex);
					logger.debug("BUFFER size Stream 6 "+Buffer_6+" "+fragIndex);
					
					logger.debug("Avg q Stream 0 "+avgQ_0);
					logger.debug("Avg q Stream 1 "+avgQ_1);
					logger.debug("Avg q Stream 2 "+avgQ_2);
					logger.debug("Avg q Stream 3 "+avgQ_3);
					logger.debug("Avg q Stream 4 "+avgQ_4);
					logger.debug("Avg q Stream 5 "+avgQ_5);
					logger.debug("Avg q Stream 6 "+avgQ_6);
				}
			}
			if(Buffer<workahead){
				setState("download");
				logger.debug("decbuff");
			}
			//			if(int(Buffer)%5==0 && Buffer!=0 && policy=="bucket"){
			//				generate_tokens();
			//			}
		}
		
		private function chosefromport(stream:int):Number
		{
			//			return 250;
			//			THIS IS THE RIGHT ONE...CHANGE AFTER FIXING PORTED CHOICE
			logger.debug("Ported choices1 "+portedChoices+" "+stream);
			var value:Number=portedChoices[stream];
			if(stream<0)
				logger.debug("stop");
			if(value>1300)
				value=1300;
			return value;
		}
		
		private function portedQuality(C:Number):void
		{
			var A:Number = 400;
			//				var C:Number = 4000;
			var N:int=6;
			var n:int=4;
			var QC:Array = [250, 500, 850, 1300];
			var w:Array = new Array;
			if(modicaPrefetchica=="equal"){
				w = [0.166,0.166,0.166,0.166,0.166,0.166];	//UNIFORM PROBABILITIES!
			}else if(modicaPrefetchica=="new_half"){
				//				w=[0.5,0,0,0,0,0.5];
				w=[0.285,0.285,0.142,0.142,0.068,0.068];
			}else{
				//				w=[0.314,0.207,0.157,0.125,0.100,0.087];
				w=[0.409,0.204,0.135,0.102,0.081,0.065];
			}
			var q:Array = [0, 0, 0, 0, 0, 0];
			
			//				cout<<"Input parameters:"<<endl;
			//				printf("C = %d\n", C);
			logger.debug("Input parameters: "+C);
			
			
			var i:int = 0;
			var j:int = 0;
			var Qsum:Number = 0;
			var Du:Number = 0.0;
			var Dq:Number = 0;
			var Dq_max:Number = 0;
			var Du_max:Number = 0;
			var i_max:int = 0;
			var U:Number = 0;
			var stop:Boolean=false;
			
			//				for (A=0; A<2000; A=A+10)
			{
				
				//					logger.debug("A = "+ A);
				stop = false; 
				j = 0;
				Qsum = 0;
				Du = 0.0;
				Dq = 0;
				Dq_max = 0;
				Du_max = 0;
				i_max = 0;
				U = 0; 
				for (i=0; i<N; i++){ 
					q[i] = 0;    
				}
				
				while (!stop)
				{
					for (i=0; i<N; i++)
					{
						Dq = 0;
						j=0;
						if (q[i]==0) 
							Dq = QC[0];
						else
							for (j=0; j<n-1; j++)
							{
								if (q[i]==QC[j]) 
									Dq= QC[j+1] - q[i];
							}
						
						if (q[i]==0) 
							Du = (Dq + A)*w[i]/Dq;
						else Du = Dq*w[i]/Dq;
						
						if (Du>Du_max)
							if (Qsum + Dq <= C)
							{
								Dq_max = Dq;
								Du_max = Du;
								i_max=i;
							}
					}// end for
					
					if (Du_max > 0)
					{
						//printf("Dq_max = %d, i_max = %d, q[%d] = %d\n", Dq_max, i_max, i_max, q[i_max] );
						q[i_max] = q[i_max] + Dq_max;
						Qsum = Qsum + Dq_max;
						i_max = 0; Dq_max = 0;
						Du_max = 0.0;   j = 0;
					}
					else
					{
						logger.debug("Ported choices: "+A+" "+C+" "+q);							
						for (i=0; i<N; i++)
							if (q[i] ==0) 
								U = U - A*w[i];
							else
								U = U + q[i]*w[i];
						
						logger.debug("Utility = "+ U);
						portedChoices=q;
						stop = true;
					}
				}// end while
			}// end for A
			//			}
		}
		
		
		public function generate_tokens(event:TimerEvent):void
		{
			if(orderedlist.length>0){ //&& global_avg!=0
				var holding:String=((orderedlist.pop()));
				tokenNum.push(transforminputs(holding,2));
				tokenId.push(transforminputs(holding,1));
				//				two tokens at the same time
				if(orderedlist.length>0){
					var holding:String=((orderedlist.pop()));
					tokenNum.push(transforminputs(holding,2));
					tokenId.push(transforminputs(holding,1));
				}
				
				//				tokenQ.push(qualitychoice());
			}
			logger.debug("Timer updated "+ tokenNum.length);
		}
		
		private function qualitychoice(off:Number):Number
		{
			var q:Array=[1300,850,500,250];
			if(prefetchpolicy=="lowest"){
				return 250;
			}
			if(prefetchpolicy=="adaptive"){
				//				var q:Array=[1300,850,500,250];
				for (var m:uint=0;m<q.length;m++){
					if((global_avg)>q[m] && ttd((q[m]*1.5))<off){	//*ORIGINAL* if((global_avg*0.6)>q[m]){
						return q[m];
						break;
					}
				}
			}
			if(prefetchpolicy=="bufferbased"){
				//				var q:Array=[1300,850,500,250];
				var value:Array=new Array;
				for(var i:uint=0;i<q.length;i++){
					value[i]=((4*q[i])/global_avg);
				}
				for(var j:uint=0;j<value.length;j++){
					if(Buffer-4 > (DesiredMin+value[j])){
						return q[j];
						break;
					}
				}
			}
			return 250;
		}
		
		private function qualitychoice1():Number
		{
			var q:Array=[1300,850,500,250];
			if(prefetchpolicy=="lowest"){
				return 250;
			}
			if(prefetchpolicy=="adaptive"){
				for (var m:uint=0;m<q.length;m++){
					if((global_avg)>q[m] && ttd((q[m]*1.5))<4){	//there is no off period that can be calculated in deadline based..so using 4 seconds instead
						return q[m];
						break;
					}
				}
			}
			if(prefetchpolicy=="bufferbased"){
				//				var q:Array=[1300,850,500,250];
				var value:Array=new Array;
				for(var i:uint=0;i<q.length;i++){
					value[i]=((4*q[i])/global_avg);
				}
				for(var j:uint=0;j<value.length;j++){
					if(Buffer-4 > (DesiredMin+value[j])){
						return q[j];
						break;
					}
				}
			}
			return 250;
		}
		
		public function gettime():Number
		{
			var now:Date = new Date();
			var epoch:Number = Math.round(now.valueOf()/1000);
			var epoch1:Number = (now.valueOf());
			return epoch1;
		}
		
		private function checkdonepath(path:String):Boolean
		{
			for(var i:uint=0; i<donePath.length;i++){
				if(donePath[i] == path){
					return true;
				}
			}
			return false;
		}
		
		private function checkavail(path:String):Boolean
		{
			for(var i:uint=0; i<availablepaths.length;i++){
				if(availablepaths[i] == path){
					return true;
				}
			}
			return false;
		}
		
		
		public function receiveFraginfo(fragDet:String,lastQuality:String):void
		{
			var max:int = fragDet.indexOf("Frag");
			lastfragment = fragDet.substring(max+4);
			lastquality = lastQuality;
		}
		
		public function receiveFraginfoalt(fragDet:Number):void
		{
			lastfragment = fragDet.toString();
		}
		
		public function compareFraginSec(fragNum1:Number):Boolean
		{		
			checkCounter = 0;
			if( fragNum1 >= (decPoints[jumpCount]*4))// || (cnt == decPoints.length-1 && (fragNum1- (decPoints[jumpCount]*4) <= 0.5)))
			{ //bad practise, but should still work 
				//					CONFIG::LOGGING
				//					{
				//				logger.debug("branchleft comp out"+ branchLeft + " "+ (landPoints) + " " + fragNum1 + " " + decPoints[jumpCount]*4 + " " + checkCounter+ " " + ((decPoints[jumpCount]*4) - fragNum1 <= 0.5));
				//					}
				return true;
			}
			//				cnt == decPoints.length-1 &&
			if(((decPoints[jumpCount]*4) - fragNum1 <= 0.5)) // <= value needs tuning at times
			{
				//					CONFIG::LOGGING
				//					{
				logger.debug("branchleft comp out"+ branchLeft + " "+ (landPoints) + " " + fragNum1 + " " + decPoints[jumpCount]*4 + " " + checkCounter+ " " + ((decPoints[jumpCount]*4) - fragNum1 <= 0.5));
				//					}
				checkCounter++;
				return true;
			} //DISABLED TO AVOID EARLY SEEK
			/*}*/
			return false;
		}
		
		public function receiveInfo(path:String):void{
			playpath1= path;
		}
		
		public function compareLandfrag(numFrag:Number):Boolean
		{
			for(var cnt:uint = 0; cnt < landPoints.length; cnt++)
			{
				if(numFrag == landPoints[cnt])
				{
					for(var loop:uint = 0; loop < availablepaths.length; loop++)
					{
						if(availablepaths[loop] == playerpath ){
							return true;
						}
					}
				}
			}
			return false;		
		}

		
		public function wheretoJump(playTime:int):void
		{
			for(var loop:uint=0; loop < availablepaths.length; loop++){
				//				logger.debug("wer to jump out" + availablepaths[loop]+ playerpath);
				if(availablepaths[loop] == playerpath){
					jumpCount = loop;
					//					logger.debug("wer to jump in" + availablepaths[loop] + " "+ playerpath+ " "+ jumpCount);
					var min:uint = 500000;
					var holding:Array = new Array;
					var indexofholding:uint = 0;
					for(var i:uint=0; i < all_jump_paths.length; i++){
						if(all_jump_paths[i].indexOf(playerpath) >= 0){
							//							logger.debug("wer to jump found "+ all_jump_paths[i]);
							//							var current_value:String = all_jump_paths[i];
							var temp:String = all_jump_paths[i].substring(1);
							var current_value:Array = temp.split(" ");
							var lenof:int= current_value.length;
							if(lenof == min){
								indexofholding++;
								holding[indexofholding] = i;
							}
							if(lenof < min){
								min = lenof;
								holding[0] = i;
							}
						}
					}
					jump_array = new Array;
					for(var r:uint=0; r <= indexofholding; r++){
						//							logger.debug("wer to jump found again"+ all_jump_paths[holding[r]]);
						var anothertemp:String = all_jump_paths[holding[r]].substring(1);
						var onemore:Array = anothertemp.split(" ");
						//							jump_array[r] = all_jump_paths[holding[r]].substring(all_jump_paths[holding[r]].length-1)
						jump_array[r] = onemore[onemore.length-1];
						//						logger.debug("wer to jump returned land "+ jump_array);
					}
				}
			}
		}
		
		public function getBranch():Boolean
		{
			timePass = netStream1.time;
			return branchLeft;	
		}
			
		public function setCurrentFragalternate(number:Number):void
		{
			subtract = 0;
			var concatdummy:String = " ";		
			var temp:String = number.toString();
			var concattemp:String = concatdummy.concat(temp);
			playerpath = playerpath.concat(concattemp);
			logger.debug("playerpath alternate"+ playerpath);
			concatdummy = " ";
			prevFrag = temp;
			wheretoJump(number);

			currentFrag = Number(prevFrag);
			//			logger.debug("set current frag " + currentFrag);
			var futureOnefrag:int = (currentFrag+1);
			var futureTwofrag:int = (currentFrag+2);
			var dummy:String = " ";
			var intermediate:String = playerpath.concat(dummy);
			var intermediate1:String = intermediate.concat(futureOnefrag.toString());
			var intermediate2:String = intermediate1.concat(dummy);
			futurepath = intermediate2.concat(futureTwofrag.toString());
			
			{
				var current_estimate:uint = (DefaultHTTPStreamingSwitchManager.givebitRate())/1024;
				qualityinbytes = Number(lastquality);
				var whichq1:Number = checkparallelquality();
				
				var prefetch:Array = compareFragalternate(currentFrag.toString());
				logger.debug("prefetchpath "+ prefetchPath);
				if(prefetch[0] != null && prefetchPath.indexOf(prefetch[0]) < 0 && pathcheck(prefetch[0]) == true){
					//					/////////////////////
					subtract = subtract+(whichq1*1000);

					var strReq:HTTPStreamRequest = new HTTPStreamRequest(HTTPStreamRequestKind.DOWNLOAD, "http://x.x.x.x/vod/final_"+(whichq1)+"Seg1-Frag" + prefetch[0]);
					var urlReq:URLStream = new URLStream();
					prefetchPath.push(prefetch[0]);
					branch_prefetchPath.push(Number(prefetch[0]));
					
					urlReq.addEventListener(Event.COMPLETE, onComplete);

					urlReq.load(strReq.urlRequest);
					dloadTimerbegin1 = gettime();
					if(whichq1 == 0.25)
						prefQ1 = 0;
					else if(whichq1 == 0.5)
						prefQ1 = 1;
					else if(whichq1 == 0.85)
						prefQ1 = 2;
					else if(whichq1 == 1.3)
						prefQ1 = 3;
					prefF1 = prefetch[0];
					fragments[prefetch[0]] = urlReq;
				}
			}
			
			var whichq:Number = checkparallelquality();
			if(prefetch.length > 1){
				subtract = subtract+(whichq*1000);
				logger.debug("prefetchpath "+ prefetchPath);
				for(var i:uint=1; i < prefetch.length; i++){
					if(prefetchPath.indexOf(prefetch[i]) < 0 && pathcheck(prefetch[i]) == true){
						prefetchPath.push(prefetch[i]);
						branch_prefetchPath.push(Number(prefetch[i]));
						var strReq1:HTTPStreamRequest = new HTTPStreamRequest(HTTPStreamRequestKind.DOWNLOAD, "http://x.x.x.x/vod/final_"+(whichq)+"Seg1-Frag" + prefetch[i]);
						var urlReq1:URLStream = new URLStream();
						urlReq1.addEventListener(Event.COMPLETE, onComplete1);
						urlReq1.load(strReq1.urlRequest);
						dloadTimerbegin2 = gettime();
						if(whichq == 0.25)
							prefQ2 = 0;
						else if(whichq == 0.5)
							prefQ2 = 1;
						else if(whichq == 0.85)
							prefQ2 = 2;
						else if(whichq == 1.3)
							prefQ2 = 3;
						prefF2 = prefetch[i];
						fragments[prefetch[i]] = urlReq1;
						logger.debug("2");
					}
				}
			}
			
			//			END OF COPY PASTE
			
		}
		
		public function checkfragmentsdict(number:uint):Boolean
		{
			if(fragments[number] == null){
				return false;
			}
			return true;
		}
		
		public function returnPlayerpath():String
		{
			return playerpath;
		}
		
		private function checkrepetition(number:int):Boolean
		{
			var splitpath:Array=playerpath.split(" ");
			for(var i:uint=0;i<splitpath.length;i++){
				if(splitpath[i]==number)
					return false;
			}
			return true;
		}
		
		public function setCurrentFrag(num:Number):void
		{
			subtract = 0;
			logger.info("last frag " + lastfragment + "num "+ num);
			CONFIG::LOGGING
			{
				//				logger.debug("set current frag " + currentFrag);
				//				logger.debug("set current frag " + mediaPlayer.currentTime);
				doneOnce = false;
			}
			
			if(num != donot_add){// && DesiredMin!=100 && DesiredMin!=0 && checkrepetition(num)==true){ // && playerpath.indexOf(num.toString()) < 0
				if(advert==false){
					if(checkrepetition(num)==true){
						
						var concatdummy:String = " ";
						//			///////////////////////////////////////////////////////				
						//				concatdummy = concatdummy.concat(lastfragment);
						//			///////////////////////////////////////////////////////
						concatdummy = concatdummy.concat(num);
						playerpath = playerpath.concat(concatdummy);
						concatdummy = " ";

						logger.debug("playerpath"+ playerpath);	

						prevFrag = lastfragment;
						wheretoJump(num);
					}
					//				}
				}
								
				currentFrag = Number(num);

				for(var cnt:uint = 0; cnt < decPoints.length; cnt++)
				{
					if(currentFrag == decPoints[cnt])
					{
						var event:Event = new Event("showAlert");
						dispatchEvent(event);
					}
				}
				//			CONFIG::LOGGING
				//			{
				//				logger.debug("branchleft3 getbranch"+ netStream1.time);
				//			}
				
				//			var futureFrag:int = (currentFrag+2);
				var futureOnefrag:int = (currentFrag+1);
				var futureTwofrag:int = (currentFrag+2);
				var dummy:String = " ";
				var intermediate:String = playerpath.concat(dummy);
				var intermediate1:String = intermediate.concat(futureOnefrag.toString());
				var intermediate2:String = intermediate1.concat(dummy);
				futurepath = intermediate2.concat(futureTwofrag.toString());
				
				{
					var current_estimate:uint = (DefaultHTTPStreamingSwitchManager.givebitRate())/1024;
					qualityinbytes = Number(lastquality);
					var whichq1:Number = checkparallelquality();
					
					var prefetch:Array = compareFragalternate(currentFrag.toString());
					logger.debug("prefetchpath "+ prefetchPath);
					if(prefetch[0] != null && prefetchPath.indexOf(prefetch[0]) < 0 && pathcheck(prefetch[0]) == true){
						subtract = subtract+(whichq1*1000);

						logger.debug("3");
						prefetchPath.push(prefetch[0]);
						branch_prefetchPath.push(Number(prefetch[0]));
						
						dloadTimerbegin3 = gettime();
						if(whichq1 == 0.25)
							prefQ3 = 0;
						else if(whichq1 == 0.5)
							prefQ3 = 1;
						else if(whichq1 == 0.85)
							prefQ3 = 2;
						else if(whichq1 == 1.3)
							prefQ3 = 3;
						prefF3 = prefetch[0];
						parallel_frag.push(prefetch[0]);
						parallel_quality.push(whichq1);
					}
				}
				
				var whichq:Number = checkparallelquality();
				if(prefetch.length > 1){
					subtract = subtract+(whichq*1000);
					logger.debug("prefetchpath "+ prefetchPath);
					for(var i:uint=1; i < prefetch.length; i++){
						if(prefetchPath.indexOf(prefetch[i]) < 0 && pathcheck(prefetch[i]) == true){
							prefetchPath.push(prefetch[i]);
							branch_prefetchPath.push(Number(prefetch[i]));

							dloadTimerbegin4 = gettime();
							if(whichq == 0.25)
								prefQ4 = 0;
							else if(whichq == 0.5)
								prefQ4 = 1;
							else if(whichq == 0.85)
								prefQ4 = 2;
							else if(whichq == 1.3)
								prefQ4 = 3;
							prefF4 = prefetch[i];
							parallel_frag.push(prefetch[i]);
							parallel_quality.push(whichq);
							logger.debug("4");
						}
					}
				}
			}
		}
		
		public function subtractreturn():uint
		{
			return subtract;
		}
		
		
		public function requestotherBranchfrag(req:URLRequest, num:Number):void
		{
			var strReq1:HTTPStreamRequest = new HTTPStreamRequest(HTTPStreamRequestKind.DOWNLOAD, req.url);
			var urlReq1:URLStream = new URLStream();
			urlReq1.addEventListener(Event.COMPLETE, onComplete);
			urlReq1.load(strReq1.urlRequest);
			//						fragments.push(urlReq1); ORIGINAL WORKING
			fragments[num] = urlReq1;
		}
		
		public function returnPrefetchpath():Array
		{
			return prefetchPath;
		}
		
		
		public function calculatefragSize():void
		{
			for(var i:uint=1;i<runtable.length;i++){
				sizearray_250[i] = ((runtable[i-1]/1000)*250);
				sizearray_500[i] = ((runtable[i-1]/1000)*500);
				sizearray_850[i] = ((runtable[i-1]/1000)*850);
				sizearray_1300[i] = ((runtable[i-1]/1000)*1300);
			}
			
		}
		
		public function pushtoStreamdownloader(Estimate:uint,FragRate:uint):void
		{
			estimate = Estimate;
			fragRate = FragRate;
		}
		
		public function receiveEstimate(Estimate:Number):void
		{
			estimate = Estimate;
		}
		
		public function receiveEstimateforStreamdownloader():int
		{
			return estimate;
		}
		
		public function receiveglobalAvgforStreamdownloader():Number
		{
			return global_avg;
		}
		
		public function receiveFragrateforStreamdownloader():int
		{
			return fragRate;
		}
		
		public function receiveRuntableforStreamdownloader():Array
		{
			return runtable;
			
		}
		
		public function receiveTimeStreamdownloader():Number
		{
			return netStream1.time;
		}
		
		public function checkparallelquality():Number
		{
			//			logger.debug("compare frag check prefetct: setq "+prefetchingquality);
			if(fileContent1 == "0.25"){
				return 0.25;
			}
			if(fileContent1 == "0.5"){
				return 0.5;
			}
			if(fileContent1 == "0.85"){
				return 0.85;
			}
			if(fileContent1 == "1.3"){
				return 1.3;
			}
			if(fileContent1 == "dynamic"){
				if(prefetchingquality == 0)
					prefetchingquality = 0.25;
				return prefetchingquality;
				
			}
			if(fileContent1 == "dynamic-1"){
				if(prefetchingquality == 0.25)
					return 0.25;
				if(prefetchingquality == 0.5)
					return 0.25;
				if(prefetchingquality == 0.85)
					return 0.5;
				if(prefetchingquality == 1.3)
					return 0.85;
			}
			
			if(fileContent1 == "lastq"){
				return Number(lastquality);
			}
			return prefetchingquality;
		}
		
		public function setprefetchquality(quality:Number):void
		{
			prefetchingquality = quality;
			
		}
		
		
		public function findLandpoint():void
		{
			for(var loop:uint=0; loop < availablepaths.length; loop++){
				if(availablepaths[loop] == futurepath){
					landNumber = loop;
				}	
			}			
		}
		
		// Iterates through all decision points to find the message corresponding to
		// the fragment being downloaded, currently not working well / at all
		public function getMessage():String
		{
			var cnt:uint = 0;
			while(cnt < messages.length)
			{
				if(decPoints[cnt] == currentFrag)
					break;
				cnt++;
			}
			//			if(messages[cnt] != null)
			//				return messages[cnt];
			
			return "Message";
		}
		
		// Returns a fragment from the vector of prefetched fragments
		// parameter: id - index in vector
		// should change to returning the fragment number the parameter specifies
		// to be less hard coded
		public function getFragment(id:int):URLStream
		{
			if(fragments[id] != null)
			{
				return fragments[id];
			}
			return null;
		}
		
		public function adgetFragment(id:int):URLStream
		{
			if(adfragments[id] != null)
			{
				return adfragments[id];
			}
			return null;
		}
		
		// Calculates how many fragments we need to skip in order to start playing at a landing fragment
		public function getNumSkips():Number
		{
			var tmp:Number = 0;
			var cnt:Number = 0;
			while(decPoints[cnt] != lastChecked)
			{
				cnt++;
			}
			
			return landPoints[cnt];
			//			return 8;
		}
		
		//		CHECK WHAT HAPPENS WITH THE FRAGNUM BASED ROUTINES
		public function compareFragExtrapolate():Array
		{
			var splitString:String = "";		
			var returnthis:Array = extrapolatepath();
			return returnthis;
		}
		
		private function extrapolatepath():Array
		{
			var holding:Array = new Array;
			for(var index:uint=0; index < all_jump_paths.length; index++){
				if(all_jump_paths[index].indexOf(playerpath) >= 0){
					holding.push(all_jump_paths[index]);
				}
			}
			var bestPrefetch:Array= findnearest(holding);
			return bestPrefetch;
		}
		
		private function findnearest(hold:Array):Array
		{
			var x:Array=new Array;
			var min:uint=9999;
			var min1:uint=9999;
			var y:Array=new Array;
			for(var i:uint;i<hold.length;i++){
				var temp:Array= hold[i].split(" ");
				if(temp.length <= min){
					x.push(hold[i]);
					min = temp.length;
				}
			}
			for(var j:uint=0;j<x.length;j++){
				var temp1:Array=x[j].split(" ");
				y.push(Number(temp1[temp1.length-1]));
			}
			return y;
		}
		
		public function compareFragalternate(fragNum:String):Array
		{
			
			//			THIS IS UNTESTED ///////START FROM HERE
			var splitString:String = "";
			var compare:Array = new Array;
			var indexofcompare:uint = 0;
			carryfragnum = Number(fragNum)+1; 		//sets the variable for switch manager routines

			for(var index:uint=0; index < all_jump_paths.length; index++){
				//				OLD VERSION
				/*if(fragNum == availablepaths[index]){
				logger.debug("compare frag check" + fragNum + " " + availablepaths[index]);
				return true;
				}
				}
				return false*/
				//				var cutpath:String= " ";
				//				if(availablepaths[index].length > 4){
				//				cutpath = availablepaths[index].slice(0,availablepaths[index].length-4);
				//				logger.debug("cutpath "+ cutpath);
				//				var cutalter:String = cutpath.slice(cutpath.length-1,cutpath.length);
				//				logger.debug("cutpath "+ cutalter);
				//				}
				
				
				//				IF ANY CURR FRAG MATCHES 2FRAGS BEFORE A PATH END, THEN RETURN TRUE, HAVE TO CHECK WHICH FRAG IS PREFETCHED HERE
				//				var a:Array = availablepaths[index].split(" ");
				if(all_jump_paths[index].indexOf(playerpath) >= 0){ // DISABLES PREFETCHING FROM OTHER BRANCHES
					//					logger.debug("cutpath allpaths "+ all_jump_paths);
					var a:Array = all_jump_paths[index].split(" ");
					//					PREFETCH NUMBER
					splitString = a[a.length-int(fileContent2)];// CONTROLS NUMBER PREFETCH BEFORE 4 or 5
					//					logger.debug("cutpath "+splitString);
					//					logger.debug("cutpath another "+ fragNum);
					if(splitString == fragNum)
					{
						//						logger.debug("cutpath true "+ index);
						//					landNumber = index;
						compare[indexofcompare] = a[a.length-1];
						indexofcompare++
						//					return true;
					}
				}
			}
			//			return false;
			//			logger.debug("cutpath final "+compare);
			return compare;
		}
		
		public function retcurrfrag():Number
		{
			return carryfragnum;
		}
		
		public function compareFragalternateforstreamingSwitch(fragNum:String):Array
		{
			//			THIS IS UNTESTED ///////START FROM HERE
			var splitString:String = "";
			var compare:Array = new Array;
			var indexofcompare:uint = 0;
			logger.debug("compare frag check dload switch" + fragNum);
			carryfragnum = Number(fragNum)+1; 		//sets the variable for switch manager routines
			for(var index:uint=0; index < all_jump_paths.length; index++){
				if(all_jump_paths[index].indexOf(playerpath) >= 0){ // DISABLES PREFETCHING FROM OTHER BRANCHES
					var a:Array = all_jump_paths[index].split(" ");
					/*PREFETCH CONTROL*/
					splitString = a[a.length-4];// CONTROLS NUMBER PREFETCH BEFORE 4 or 5
					if(splitString == fragNum){
						compare[indexofcompare] = a[a.length-1];
						indexofcompare++
					}
				}
			}
			return compare;
		}
		
		
		// Parses the text file downloaded in the constructor, will also start downloads depending on
		// data in text file.
		private function processFile(event:Event):void
		{
			var loader:URLLoader = URLLoader(event.target);
			fileContent = loader.data;
			var tempStr:String = fileContent.substr(0, fileContent.indexOf("\r\n"));
			
			var start:Number = fileContent.indexOf("length:");
			tempStr = fileContent.substring((start + 8), fileContent.indexOf("\r\n", start));
			var nums:Array = new Array;
			nums = tempStr.split(" ");
			
			for(var numNums:uint = 1; numNums < nums.length; numNums++)
			{
				branchLengths.push(nums[numNums]);
				
			}
			var fragof:Array = new Array;
			var prevVal:uint = 1;
			var concat1:String = "";
			var concatdummy:String = " ";
			for(var k:uint=0; k < branchLengths.length; k++){
				for(var g:uint=prevVal; g<branchLengths[k]+prevVal; g++){
					var h:String = g.toString();
					concatdummy = concatdummy.concat(h);
					concat1 = concat1.concat(concatdummy);
					concatdummy = " ";
				}
				prevVal = g;
				fragof.push(concat1);
				//				logger.debug("well frag "+fragof);
				concat1 = "";
				//				logger.debug("PATTEX hela concat " + concat1);
			}
					
			var startTree:Number = fileContent.indexOf("begin ");
			var endTree:Number = fileContent.indexOf("end\r\n", startTree);
			
			var dec:Number = 0;
			var dec1:Number = 0;
			tempStr = fileContent.substring(startTree+6, endTree);
			//			logger.debug("PATTEX string: " +  tempStr);
			var split:Array = new Array;
			split = tempStr.split("\r\n");
			
			var pathsofar:String = "";
			var branchPars:Array = new Array;
			for(var treeNum:uint=0; treeNum < split.length; treeNum++)
			{
				var temp1:String = split[treeNum].toString();
				for(var splitNum:uint=0; splitNum <= temp1.length; splitNum++)
				{
					
					if(temp1.charAt(splitNum) == ",")
					{
						var cnt:int = splitNum + 1;
						while(!isNaN(Number(temp1.charAt((cnt)))) && cnt < temp1.length && temp1.charAt(cnt) != " ")
						{
							cnt++;
						}
						var land:uint = 0;

						var parsNum:Number = Number(temp1.substring(splitNum+1, cnt));

						for(var sumCnt1:uint = 0; sumCnt1 < (parsNum-1); sumCnt1++)
						{
							land += branchLengths[sumCnt1];
							
							var a:uint = land+1;
						}

						if(land != 0)
							landPoints.push(land+1); // We need to search past the all previous fragments
					}
					if(temp1.charAt(splitNum) == "," && temp1.charAt(splitNum-2) == "(")
					{
						var cnt1:int = splitNum - 1;
						while(!isNaN(Number(temp1.charAt((cnt1)))) && cnt1 < temp1.length && temp1.charAt(cnt1) != " ")
						{
							cnt1++;
						}
						var noland:uint = 0;
						var parsNum1:Number = Number(temp1.substring(splitNum-1, cnt1));

						for(var sumCnt2:uint = 0; sumCnt2 < parsNum1 -1; sumCnt2++)
						{
							noland += branchLengths[sumCnt2];
													
						}

						if(noland != 0)
							nolandPoints.push(noland+1); // We need to search past the all previous fragments
					}
					
					if(temp1.charAt(splitNum) == "("){
						var cnt2:int = splitNum - 1;
						while(!isNaN(Number(temp1.charAt((cnt2)))) && cnt2 < temp1.length && temp1.charAt(cnt2) != " ")
						{
							cnt2++;
							//						logger.debug("PATTEX hela cnt2 arrayen: " + cnt2);
						}
						var branch:uint = 0;
						land =0;
						var parsNum2:String = temp1.substring(0, cnt2);
						branchPars.push(parsNum2);
						var cnt3:int=splitNum+1;
						
						while(!isNaN(Number(temp1.charAt((cnt3)))) && cnt3 < temp1.length && temp1.charAt(cnt3) != " ")
						{
							cnt3++;
						}
						
						var parsNum4:Number = Number(temp1.substring(splitNum+1, cnt3));
						
						for(var sumCnt4:uint = 0; sumCnt4 < (parsNum4-1); sumCnt4++)
						{
							land += branchLengths[sumCnt4];
							
							var b:uint = land+1;
						}
						logger.debug("PATTEX hela land: " + b);
						//						ADDED INORDER TO ADD THE FIRST BRANCH INTO PREFETCH PATH
						if(land != 0)
							firstlandPoints.push(land+1); // We need to search past the all previous fragments					
					}
				}
				
				
				for(var outervar:uint = 0; outervar <= temp1.length; outervar++)
				{
					if(temp1.charAt(outervar) == "(" && !isNaN(Number(temp1.charAt(outervar-1))) && outervar != 0){
						dec = Number(temp1.charAt(outervar-1));
						logger.debug("PATTEX hela arrayen: " + decPoints);//[0] + " " + decPoints[1]);// + " " + decPoints[2] + " " + decPoints[3]);
						
						for(var sumCnt:uint = 0; sumCnt <= dec-1; sumCnt++)
						{
							dec1 += branchLengths[sumCnt];
						}
						decPoints.push(Number(dec1));
						dec1=0;
					}
					
					if(temp1.charAt(outervar) == "(" && temp1.charAt(outervar-1)=="*" && outervar != 0){
						var star:int=(outervar-4);
						dec = Number(temp1.substring((star+1),(outervar-1)));
						logger.debug("PATTEX hela arrayen: " + decPoints);//[0] + " " + decPoints[1]);// + " " + decPoints[2] + " " + decPoints[3]);
						
						for(var sumCnt3:uint = 0; sumCnt3 <= dec-1; sumCnt3++)
						{
							dec1 += branchLengths[sumCnt3];
						}
						decPoints.push(Number(dec1));
						dec1=0;	
					}
					
				}
				
			}

			for(var j:uint=0; j < branchPars.length; j++){
				var upper:uint=1;
				var inter:String = branchPars[j].toString();
				for(var u:uint=0; u < inter.length; u++){
					if(inter.charAt(u)!="*" && inter.charAt(u-1)!="*" && inter.charAt(u-2)!="*"){
						var parsNum3:String = inter.substring(u, upper);
					}
					if(inter.charAt(u)=="*"){
						var temp:int=(u+1);
						var parsNum3:String = inter.substr(temp, 2);
						u++;
						u++;
					}

					pathsofar = pathsofar.concat(fragof[Number(parsNum3)-1]);
					upper++;
				}
				availablepaths.push(pathsofar);
				pathsofar = "";
			}
			
		
			for(var counter:uint=0; counter < split.length; counter++){
				var holding:String = split[counter].toString();
				for(var innercount:uint=0; innercount < holding.length; innercount++){
					if(holding.charAt(innercount) == "("){
						var openlocation:uint = innercount;						
					}
					
					if(holding.charAt(innercount) == ")"){
						var closelocation:uint = innercount;
					}
				}
				var split_bracket:String = holding.substring(openlocation,closelocation+1);
				var only_branches:String = split_bracket.substring(1,split_bracket.length-1);
				if(only_branches.length > 1){
					var sub_only_branches:Array = only_branches.split(",");
					for(var aalt:uint=0; aalt < sub_only_branches.length; aalt++){
						var tempo1:Array = fragof[sub_only_branches[aalt]-1].split(" ");
						var blank1:String = " ";
						var firstAfterjump1:String = blank1.concat(tempo1[1]);
						var another_concat:String = availablepaths[counter].concat(firstAfterjump1);//fragof[sub_only_branches[a]-1]
						all_jump_paths.push(another_concat);
						another_concat = "";
					}
				}
				if(only_branches.length == 1){
					var tempo:Array = fragof[Number(only_branches)-1].split(" ");
					var blank:String = " ";
					var firstAfterjump:String = blank.concat(tempo[1]);
					var another_concat1:String = availablepaths[counter].concat(firstAfterjump);//fragof[Number(only_branches)-1]
					all_jump_paths.push(another_concat1);
					another_concat1 = "";
				}
			}
			
			var offset:int = 0;
			tempStr = fileContent.substr(fileContent.indexOf("r:"));
			while(offset < tempStr.length)
			{
				var num:Number = tempStr.substr(offset).indexOf("\r\n");
				var msgStr:String = tempStr.substring(offset, offset + num);
				offset += msgStr.length + 3;
				message = msgStr.substring((msgStr.indexOf("r:") + 2), msgStr.indexOf("::"));
				message += ("\n" + msgStr.substring((msgStr.indexOf("l:") + 2)));
				messages.push(message);
			}
			
			
			var ev:Event = new Event(Event.COMPLETE);
			dispatchEvent(ev);
			logger.debug("hela land arrayen: "+landPoints);
		}
		
		
		// Logging function
		
		public function parallel_pipe_alt(frag:uint,rate:Number):void
		{
			if(parallelpipe_on_alt == false && downloadedlist[frag]==null){
				numberinParallel++;
				downloadedlist[frag]=frag;
				if(rate == 250)
					rate = 0.25;
				if(rate == 500)
					rate = 0.5;
				if(rate == 850)
					rate = 0.85;
				if(rate == 1300)
					rate = 1.3;
				var strReq2:HTTPStreamRequest = new HTTPStreamRequest(HTTPStreamRequestKind.DOWNLOAD, "http://x.x.x.x/vod/final_"+rate+"Seg1-Frag" + (frag));
				var urlReq2:URLStream = new URLStream();
				logger.debug("In parallel download "+ "http://x.x.x.x/vod/final_"+rate+"Seg1-Frag" + (frag)+ " "+ frag+ " "+ rate);
				prefestF1_alt = (frag);
				prefestQ1_alt = (rate*1000);
				fragmentQ[frag] =(rate*1000);
				logger.debug("3");

				urlReq2.addEventListener(Event.COMPLETE, onCompleteEst_alt);
				urlReq2.load(strReq2.urlRequest);  
				dloadTimerbeginest_alt = gettime();
				parallelpipe_on_alt = true;
				
				fragments[prefestF1_alt] = urlReq2;
			}
			else (parallel_pipe_alt1(frag,rate));
		}
		
		public function parallel_pipe_alt1(frag:uint,rate:Number):void
		{
			if(parallelpipe_on_alt1 == false && downloadedlist[frag]==null){
				numberinParallel++;
				//				downloadedlist.push((frag));
				downloadedlist[frag]=frag;
				if(rate == 250)
					rate = 0.25;
				if(rate == 500)
					rate = 0.5;
				if(rate == 850)
					rate = 0.85;
				if(rate == 1300)
					rate = 1.3;
				var strReq2:HTTPStreamRequest = new HTTPStreamRequest(HTTPStreamRequestKind.DOWNLOAD, "http://x.x.x.x/vod/final_"+rate+"Seg1-Frag" + (frag));

				var urlReq2:URLStream = new URLStream();
				logger.debug("In parallel download "+ "http://x.x.x.x/vod/final_"+rate+"Seg1-Frag" + (frag)+ " "+ frag+ " "+ rate);
				prefestF1_alt1 = (frag);
				prefestQ1_alt1 = (rate*1000);
				fragmentQ[frag] =(rate*1000);
				logger.debug("3");
				urlReq2.addEventListener(Event.COMPLETE, onCompleteEst_alt1);
				urlReq2.load(strReq2.urlRequest);  
				dloadTimerbeginest_alt1 = gettime();
				parallelpipe_on_alt1 = true;
				
				fragments[prefestF1_alt1] = urlReq2;
			}else{
				parallel_pipe_exc(frag,rate);
			}
			

		}
		
		//		}
		
		public function parallel_pipe_exc(frag:uint,rate:Number):void
		{
			if(parallelpipeexc_on == false && downloadedlist[frag]==null){
				parallelpipeexc_on = true;
				numberinParallel++;
				downloadedlist[frag]=frag;
				if(rate == 250)
					rate = 0.25;
				if(rate == 500)
					rate = 0.25;
				if(rate == 850)
					rate = 0.5;
				if(rate == 1300)
					rate = 0.85;
				var strReq2:HTTPStreamRequest = new HTTPStreamRequest(HTTPStreamRequestKind.DOWNLOAD, "http://x.x.x.x/vod/final_"+rate+"Seg1-Frag" + (frag));
				var urlReq2:URLStream = new URLStream();
				logger.debug("In parallel download "+ "http://x.x.x.x/vod/final_"+rate+"Seg1-Frag" + (frag)+ " "+ frag+ " "+ rate);
				prefestF1_exc = (frag);
				prefestQ1_exc = (rate*1000);
				fragmentQ[frag] =(rate*1000); 
				logger.debug("3");

				urlReq2.addEventListener(Event.COMPLETE, onCompleteEst_exc);
				urlReq2.load(strReq2.urlRequest);
				dloadTimerbeginest_exc = gettime();
				
				fragments[prefestF1_exc] = urlReq2;
			}else if(downloadedlist[frag]==null){
				//			else (parallel_pipe_alt(frag,rate));
				logger.debug("Missed this "+ frag);
				missed_fragments.push(frag);
				missed_quality.push(rate);
				parallel_pending=true;
			}
		}
		
		public function onCompleteEst_exc(event:Event):void
		{
			dloadTimerendest_exc = gettime();
			parallelpipeexc_on = false;
			time_download[prefestF1_exc] = (dloadTimerendest_exc-dloadTimerbeginest_exc)/1000;
			quality_download[prefestF1_exc] = prefestQ1_exc;
			logger.debug("download info "+ time_download[prefestF1_exc]+ " "+ quality_download[prefestF1_exc]+ " "+prefestF1_exc);
			numberinParallel--;
			var estimate:Number = (((fragments[prefestF1_exc].bytesAvailable)*8/1000)/((dloadTimerendest_exc-dloadTimerbeginest_exc)/1000));

			Buffer+=(runtable[prefestF1_exc-1]/1000);
			if(numberinParallel!=0)
				estimate=estimate*numberinParallel;
			calculate_avg(estimate,quality_download[prefestF1_exc]);			
			if(seeking==false)
				checkandschedule(global_avg,maxinParallel);
			//			NEEDS A CALL TO STREAM DOWNLOADER AND SHOULD RETURN TO PARALLELPIPE
			//((masterSizeList[prefF1][prefQ1])/(dloadTimerend1-dloadTimerbegin1)));
		}
		
		public function getTimetoSeek():Number
		{
			var knownTime:Number;
			if(prevMediaPlayer!=null){
				knownTime=prevMediaPlayer.currentTime;
			}else if(prevMediaPlayer==null){
				knownTime=netStream1.time;
			}
			return knownTime;
		}
		
		private function dummy(event:TimerEvent):void
		{
			try
			{
				if(parallelpipe_on_alt == false && parallelpipe_on_alt1 == false && parallelpipe_on == false && parallelpipeexc_on == false && netStream1.time>2 && estimate != 0 && seeking==false){
					if(global_avg!=0){
						checkandschedule(global_avg,maxinParallel);
					}else{
						checkandschedule(estimate,maxinParallel);
					}
				}
			}
			catch(error:Error)
			{
				trace("Some error occured8: " + error.message);
			}
		}
		
		public function passedpipe(frag:uint,rate:Number):void
		{
			if(parallelpipe_on == false && downloadedlist[frag]==null && rate!=0){
				if(rate == 250)
					rate = 0.25;
				if(rate == 500)
					rate = 0.5;
				if(rate == 850)
					rate = 0.85;
				if(rate == 1300)
					rate = 1.3;
				
				var strReq2:HTTPStreamRequest = new HTTPStreamRequest(HTTPStreamRequestKind.DOWNLOAD, "http://x.x.x.x/vod/final_"+rate+"Seg1-Frag" + (frag));
				var urlReq2:URLStream = new URLStream();
				logger.debug("In parallel download "+ "http://x.x.x.x/vod/final_"+rate+"Seg1-Frag" + (frag)+ " "+ frag+ " "+ rate);
				urlReq2.load(strReq2.urlRequest);  
				parallelpipe_on = true;
			}
			else if(downloadedlist[frag]==null){
				logger.debug("Missed this "+ frag);
				missed_fragments.push(frag);
				missed_quality.push(rate);
				parallel_pending=true;
			}
		}
		
		public function parallel_pipe(frag:uint,rate:Number,current_stream:int,id:String):void
		{
			downloadedlist=chosedownloadedlist(current_stream);
			lastStream=current_stream;
			qualitylist=chosequalitylist(current_stream);
			if(parallelpipe_on == false && downloadedlist[frag]==null && adpipe_on==false){
				numberinParallel++;
				downloadedlist[frag]=frag;
				qualitylist[frag]=rate;
				setdownloadedlist(downloadedlist,current_stream);
				setqualitylist(qualitylist,current_stream);
				if(rate == 250)
					rate = 0.25;
				if(rate == 500)
					rate = 0.5;
				if(rate == 850)
					rate = 0.85;
				if(rate == 1300)
					rate = 1.3;
				if(current_stream==0){
					var strReq2:HTTPStreamRequest = new HTTPStreamRequest(HTTPStreamRequestKind.DOWNLOAD, "http://x.x.x.x/vod/final_"+rate+"Seg1-Frag" + (frag));
				}else if(current_stream>0){
					var strReq2:HTTPStreamRequest = new HTTPStreamRequest(HTTPStreamRequestKind.DOWNLOAD, "http://x.x.x.x/vod/final_"+rate+"_"+current_stream+"Seg1-Frag" + (frag));
				}
				var urlReq2:URLStream = new URLStream();
				if(current_stream==0)
					logger.debug("In parallel download "+ "http://x.x.x.x/vod/final_"+rate+"Seg1-Frag" + (frag)+ " "+ frag+ " "+ rate+" "+current_stream+" "+id);
				else if(current_stream>0)
					logger.debug("In parallel download "+ "http://x.x.x.x/vod/final_"+rate+"_"+current_stream+"Seg1-Frag" + (frag)+ " "+ frag+ " "+ rate+" "+current_stream+" "+id);
				prefestF1 = (frag);
				prefestQ1 = (rate*1000);
				fragmentQ[frag] =(rate*1000); 
				logger.debug("3");
				urlReq2.addEventListener(Event.COMPLETE, onCompleteEst);
				dloadTimerbeginest = gettime();
				urlReq2.load(strReq2.urlRequest);
				parallelpipe_on = true;
				
				fragments[prefestF1] = urlReq2;
				
				{
					
					var w:Array = new Array;
					if(modicaPrefetchica=="equal"){
						w = [0.166,0.166,0.166,0.166,0.166,0.166];
					}else if(modicaPrefetchica=="new_half"){
						w=[0.285,0.285,0.142,0.142,0.068,0.068];
					}else{
						//						w=[0.314,0.207,0.157,0.125,0.100,0.087]; //ZIPF
						w=[0.409,0.204,0.135,0.102,0.081,0.065];
					}
					var ptr:int=positions.indexOf(lastStream);
					var weight:Number=w[ptr];
					if(ptr<0){
						weight=1;
					}
					//				logger.debug("The current stream is "+currentStream+" shown stream is "+j+map stream weight based on location of position array.and quality based on quality array..!
					logger.debug("Downloaded Stream "+lastStream+" chunk "+prefestF1+" with weight "+weight+" time "+getTimetoSeek()+" quality "+prefestQ1);
				}
				
			}
			else if(downloadedlist[frag]==null){
				missed_fragments.unshift(frag);
				missed_quality.unshift(rate);
				missed_stream.push(current_stream);
				logger.debug("Missed this "+ missed_fragments+ " "+current_stream);
				parallel_pending=true;
			}
		}
		
		public function ad_pipe_opp(frag:uint,rate:Number):void
		{
			if(adpipe_on==false && prefetching=="true"){			
				adarray.push(frag);
				adqualitylist[frag]=rate;
				var strReq2:HTTPStreamRequest = new HTTPStreamRequest(HTTPStreamRequestKind.DOWNLOAD, "http://x.x.x.x/vod/advert"+adID+"_"+rate+"Seg1-Frag"+(frag));
				var urlReq2:URLStream = new URLStream();
				logger.debug("In parallel download "+ "http://x.x.x.x/vod/advert"+adID+"_"+rate+"Seg1-Frag" + (frag)+ " "+ frag+ " "+ rate);
				addownloadedlist["http://x.x.x.x/vod/advert"+adID+"_Seg1-Frag" + (frag)]=frag;
				adprefestF1 = (frag);
				adprefestQ1 = (rate);
				urlReq2.addEventListener(Event.COMPLETE, onpipeComplete);
				urlReq2.load(strReq2.urlRequest);  
				addloadTimerbeginest = gettime();
				adpipe_on = true;
				adfragments[frag] = urlReq2;
				if(admissed_fragments.indexOf(frag)>0){
					admissed_fragments.splice(admissed_fragments.indexOf(frag),1)
				}
				var decision:Boolean=checkAddprefetched(frag)
				if(decision==true&& adID==15 && onetwocomplete==false){
					onetwocomplete=true;
					ad_downloadlist=new Array;
					adarray=new Array;
					adID=0;
				}
				else if (decision==true && adID<15){
					ad_downloadlist=new Array;
					adarray=new Array;
					adID++;
				}
			}
			else if(adpipe_on==true && prefetching=="true"){
				logger.debug("Missed this "+ frag);
				if(admissed_fragments.indexOf(frag)<0){
					admissed_fragments.unshift(frag);
					admissed_quality.unshift(rate);				
					adparallel_pending=true;
				}
			}
		}
		
		public function ad_pipe(frag:uint,rate:Number,id:int,caller:int):void
		{			
			if(adpipe_on==false && prefetching=="true" && parallelpipe_on==false){// && addownloadedlist["http://x.x.x.x/vod/advert"+id+"_Seg1-Frag" + (frag)]==null			
				adarray.push(frag);
				adqualitylist[frag]=rate;
				var strReq2:HTTPStreamRequest = new HTTPStreamRequest(HTTPStreamRequestKind.DOWNLOAD, "http://x.x.x.x/vod/advert"+id+"_"+rate+"Seg1-Frag"+(frag));
				var urlReq2:URLStream = new URLStream();
				logger.debug("In parallel download "+ "http://x.x.x.x/vod/advert"+id+"_"+rate+"Seg1-Frag" + (frag)+ " "+ frag+ " "+ rate+ " "+caller);
				addownloadedlist["http://x.x.x.x/vod/advert"+id+"_Seg1-Frag" + (frag)]=frag;
				adprefestF1 = (frag);
				adprefestQ1 = (rate);
				urlReq2.addEventListener(Event.COMPLETE, onpipeComplete);
				urlReq2.load(strReq2.urlRequest);  
				addloadTimerbeginest = gettime();
				adpipe_on = true;
				adfragments[frag] = urlReq2;
				if(admissed_fragments.indexOf(frag)>0){
					admissed_fragments.splice(admissed_fragments.indexOf(frag),1)
				}
			}
			else if( (adpipe_on==true || parallelpipe_on==true) && prefetching=="true"){
				logger.debug("Missed this "+ frag+ "id "+id);
				if(admissed_fragments.indexOf(frag)<0 && frag <=2){
					admissed_fragments.push(frag);
					admissed_quality.push(rate);
					admissed_id.push(id);
					adparallel_pending=true;
				}
			}
		}
		
		public function ad_pipe_parallel(frag:uint,rate:Number):void
		{
			logger.debug("In parallel download out "+ "http://x.x.x.x/vod/advert"+adID+"_"+rate+"Seg1-Frag" + (frag)+ " "+ frag+ " "+ rate);
			if(adpipe_parallel_on==false && prefetching=="true"){			
				adarray.push(frag);
				adqualitylist[frag]=rate;
				var strReq2:HTTPStreamRequest = new HTTPStreamRequest(HTTPStreamRequestKind.DOWNLOAD, "http://x.x.x.x/vod/advert"+adID+"_"+rate+"Seg1-Frag"+(frag));
				var urlReq2:URLStream = new URLStream();
				logger.debug("In parallel download "+ "http://x.x.x.x/vod/advert"+adID+"_"+rate+"Seg1-Frag" + (frag)+ " "+ frag+ " "+ rate);
				addownloadedlist["http://x.x.x.x/vod/advert"+adID+"_Seg1-Frag" + (frag)]=frag;
				adprefestF1 = (frag);
				adprefestQ1 = (rate);
				urlReq2.addEventListener(Event.COMPLETE, onpipeComplete);
				urlReq2.load(strReq2.urlRequest);  
				addloadTimerbeginest = gettime();
				adpipe_parallel_on = true;
				adfragments[frag] = urlReq2;
				if(admissed_fragments.indexOf(frag)>0){
					admissed_fragments.splice(admissed_fragments.indexOf(frag),1)
				}
				adID=checkAddprefetchedparallel(frag)
			}
			else if(adpipe_parallel_on==true && prefetching=="true"){
				logger.debug("Missed this "+ frag);
				if(admissed_fragments.indexOf(frag)<0){
					admissed_fragments.push(frag);
					admissed_quality.push(rate);				
					adparallel_pending=true;
				}
			}
		}
		
		private function checkAddprefetched(fragment:int):Boolean
		{
			if(adarray.length==2 && admissed_fragments.length==0){
				return true;
			}
			return false;
		}
		
		private function checkAddprefetchedparallel(fragment:int):int
		{	
			if(adID<=1){
				adID++;
			}
			else if(adID==2){
				adID=0;
				ad_downloadlist=new Array;
			}
			return adID;
		}
		
		public function Choose_estimate(ewma:Number,chunkbased:Number):Number
		{
			var min:Number=0;
			if(ewma>=chunkbased){
				min=chunkbased;
			}else{
				min=ewma;
			}
			return min;				
		}
		
		public function calculate_avg(est:Number,q:Number):void
		{
			if((global_avg != 0 || current_est != 0) && est != Infinity){
				
				global_avg = (alpha*current_est)+((1-alpha)*est);
				global_avg=(global_avg*0.8);  //*0.8
				current_est = global_avg;
				logger.debug("Rolling avg :1 "+ global_avg);
			}
			
			if(global_avg == 0 || current_est == 0){
				current_est = (est*0.8);
				/*current_est = (est);*/
				global_avg = current_est;
				logger.debug("Rolling avg :2 "+ global_avg);
			}
			if(est == Infinity){
				logger.debug("Rolling avg :3 "+ global_avg);
			}
			last_downloadrate=est
			reach_max_in=villvihaoff(global_avg,q);			
		}
		
		private function villvihaoff(average:Number,quality:Number):Number
		{
			var timepersecond:Number=quality/average;
			var to_download:Number=DesiredMax-Buffer;
			var time_to_max:Number=to_download*timepersecond;
			return time_to_max;
		}
		
		private function onpipeComplete(event:Event):void
		{
			entered=false;
			logger.debug("ad download complete");
			adpipe_on=false;
			adpipe_parallel_on=false;
			//			calculate_avg(estimate,adprefestQ1);
			var myTimer2:Timer = new Timer(400, 1); // 1 second
			myTimer2.addEventListener(TimerEvent.TIMER, checkidle);
			myTimer2.start();
		}
		
		
		public function onCompleteEst(event:Event):void
		{
			entered=false;
			dloadTimerendest = gettime();
			Buffer=choseBuffer(lastStream);
			//NEED SIMILAR STUFF TO TRACK QUALITY
			BufferHolder=choseBufferHolder(lastStream);
			BufferHolder.push(prefestF1);
			setBufferHolder(BufferHolder,lastStream);
			QHolder=choseQHolder(lastStream);

			QHolder[prefestF1]=prefestQ1;
			setQHolder(QHolder,lastStream);
			parallelpipe_on = false;
			time_download[prefestF1] = (dloadTimerendest-dloadTimerbeginest)/1000;
			quality_download[prefestF1] = prefestQ1;
			logger.debug("download info "+ time_download[prefestF1]+ " "+ quality_download[prefestF1]+ " "+prefestF1);

			numberinParallel--;

			var estimate:Number = (((fragments[prefestF1].bytesAvailable)*8/1000)/((dloadTimerendest-dloadTimerbeginest)/1000));
			
			Buffer+=(runtable[prefestF1-1]/1000);
			logger.debug("adding buffer "+Buffer+ " "+runtable[prefestF1-1]/1000+" "+prefestF1+" "+lastStream);
			setBuffer(Buffer,lastStream);
			if(numberinParallel!=0)
				estimate=estimate*numberinParallel;
			calculate_avg(estimate,quality_download[prefestF1]);			
			if(seeking==false)
				checkandschedule(global_avg,maxinParallel);
			var myTimer2:Timer = new Timer(400, 1); // 1 second
			myTimer2.addEventListener(TimerEvent.TIMER, checkidle);
			myTimer2.start();
			//			NEED TO ADD STUFF HERE
			//			for(var k:int=0;k<BufferHolder.length;k++)
			
		}
		
		public function checkidle(event:TimerEvent):void
		{
			if(entered==false){
				var dummy:int=0; 
				extradummy();
			}
		}
		
		private function extradummy():void
		{
			try
			{
				if(parallelpipe_on_alt == false && parallelpipe_on_alt1 == false && parallelpipe_on == false && parallelpipeexc_on == false && netStream1.time>2 && estimate != 0 && seeking==false){
					logger.debug("Entered special init")
					if(global_avg!=0){
						checkandschedule(global_avg,maxinParallel);
					}else{
						checkandschedule(estimate,maxinParallel);
					}
				}
			}
			catch(error:Error)
			{
				trace("Some error occured8: " + error.message);
			}
		}
		
		public function checkfirstlandpoint(number:uint):Boolean
		{
			for(var i:uint=0;i<firstlandPoints.length;i++){
				
				if(number==firstlandPoints[i]){
					return true;
				}
			}
			return false;
		}
		
		private function enhanceBandwidth(connection:Array,quality:Array):int
		{
			var nettBw:Array=new Array;
			for(var bwLoop:int=0; bwLoop<connection.length-1;bwLoop++){
				nettBw[bwLoop] = connection[bwLoop]*quality[bwLoop];
			}
			return findmax(nettBw);
			
		}
		
		private function newoptimize(connection:Array,quality:Array):int
		{
			return 0;
		}
		
		private function enhanceQ(connection:Array,quality:Array):int
		{
			var maxVal:Number = 0;
			var maxValIndex:Array = new Array;
			var maxConn:Number=0;
			var holding:Number=0;
			
			for(var i:Number = 0; i < quality.length; i++){
				if(quality[i] > maxVal){
					maxVal = quality[i];
				}
			}
			
			for(var j:Number = 0; j < quality.length; j++){
				if(quality[j] == maxVal)
					maxValIndex.push(j);
			}
			for(var k:Number=0; k< maxValIndex.length;k++){
				var x:int=maxValIndex[k];
				if(connection[x] > maxConn){
					maxConn=connection[x];
					holding = x;
				}
			}
			
			if(qmax_saveq!=0 && (qmax_saveq-maxVal)>=2 && numberinParallel>1){
				return 100;
			}		
			qmax_saveq=maxVal;
			qmax_savec=maxConn;
			return holding;
		}
		
		private function findmax(est:Array):int
		{
			var max:int=0;
			var index:int=0;
			for(var i:uint=0;i<est.length;i++){
				if(est[i]>max){
					max = est[i];
					index = i;
				}
			}
			return index;
		}
		
		
		private function findmax_alt(est:Array):int
		{
			var max:int=0;
			var index:int=0;
			for(var i:uint=0;i<est.length;i++){
				if(est[i]>=max){
					max = est[i];
					index = i;
				}
			}
			return index;
		}
		
		private function calculateBranchfrags(decpoint:int):void
		{
			branchArray=new Array;
			for(var i:uint=0;i<all_jump_paths.length;i++){
				var temp:Array=all_jump_paths[i].split(" ");
				if(temp[temp.length-2]==decpoint){
					match_array=new Array;
					for(var j:uint=1;j<temp.length-1;j++){
						match_array.push(temp[j]);
					}
					if(branchArray.indexOf(temp[temp.length-1])<0)
						branchArray.push(temp[temp.length-1]);					
				}			
			}	
		}
		
		public function calcexpectedcompletion_alt(size:uint,esti:Number,frag_num:uint):Number
		{
			if(frag_num<=3)
				esti=esti*0.5;
			var comp_time:Number = size/(esti*0.9);
			storedtime+=comp_time;
			return storedtime;
		}
		
		private function calculateparams():void
		{
			var B:int=0;
			if(scenario=="nonlinear"){
				B=branchArray.length;
				DesiredMin= (buf_min*B);
				DesiredMax=((buf_min*B)+buf_margin);
				if(DesiredMin==0){
					DesiredMin=100;
					DesiredMax=110;
				}				
			}else if(scenario=="linear"){
				B=2;
				DesiredMin= (buf_min*B);
				DesiredMax=((buf_min*B)+buf_margin);
				if(DesiredMin==0){
					DesiredMin=100;
					DesiredMax=110;
				}
			}
		}
		

		private function checkconstraint(curs:Array):Boolean
		{
			for(var i:uint=0;i<curs.length-1;i++){
				if(curs[i]>=curs[i+1]){
					//					trace("ok");
				}else{
					return false;
				}
				//				return true;
			}
			return true;
		}
		
		public function subsetFill(values:Array, cursor:Array, result:Array, length:uint):void {
			if (cursor.length > length) {
				return;
			}
			if (cursor.length == length) {
				if(checkconstraint(cursor)==true)
					result.push(cursor.slice());
			}
			
			var i:uint, len:uint = values.length;
			
			for (i; i < len; ++i) {
				cursor.push(values[i]);
				subsetFill(values, cursor.slice(), result, length);
				cursor.length = cursor.length - 1;
			}
		}
		
		//Auxiliary method for tracing 
		public function prettyPrint(list:Array):void {
			var i:uint, len:uint = list.length;
			
			for (i; i < len; ++i) {
				trace(list[i]);
			}
		}
		
		public function calculate_bytes(inparray:Array,doarray:Array,bw:Number):Number
		{
			var file:Array=new Array;
			var bytes:int=0;
			for(var i:uint=0;i<inparray.length;i++){
				if(inparray[i]==1300)
					file = sizearray_1300;
				else if(inparray[i]==850)
					file = sizearray_850;
				else if(inparray[i]==500)
					file = sizearray_500;
				else if(inparray[i]==250)
					file = sizearray_250;
				
				bytes = bytes+(file[doarray[i]]);
			}
			var tempo:Number=bytes/(bw);
			return tempo;
		}
		
		public function remove(array:Array,length1:int,length2:int):Boolean
		{
			for(var i:uint=length1;i<length2;i++){
				if(array[i]==250){
					//					trace("ok")
				}else{
					return false;
				}
			}
			return true;
		}
		
		
		public function purgearray(combo:Array,branch:Array,todo:Array):Array
		{
			var purged:Array=new Array;
			for(var sub_index:uint=0;sub_index<combo.length;sub_index++){
				var combi:Array=combo[sub_index];
				if(remove(combi,todo.length-branch.length,todo.length)==true){
					purged.push(combi);
				}
				
			}
			return purged;
		}
		
		public function calculatesum(input:Array,todo:Array,branchlength:Array):Number
		{
			var sum:Number=0;
			var value:int=0;
			
			for(var i:uint=0;i<input.length;i++){
				var weight:Number=1;
				if(input[i]==1300)
					value=4
				if(input[i]==850)
					value=3
				if(input[i]==500)
					value=2
				if(input[i]==250)
					value=1
				
				if(i >= (todo.length-branchlength.length))
					weight=(value/branchlength.length);
				
				
				sum = sum+(value*weight);
			}
			return sum;
		}
		
		public function calculatebest(input:Array,todo:Array,branchlength:Array):int
		{
			var sumarray:Array=new Array;
			for(var sub_index:uint=0;sub_index<input.length;sub_index++){
				var combi:Array=input[sub_index];
				sumarray.push(calculatesum(combi,todo,branchlength));				
			}
			var index:int=findmax_alt(sumarray);
			return index;
		}
		
		public function calculatebest_alt(index1:int,index2:int,input1:Array,input2:Array,todo:Array,branchlength:Array):int
		{
			var sumarray:Array=new Array;
			
			var array1:Array=input1[index1];
			var array2:Array=input1[index2];
			
			var sum1:Number=calculatesum(array1,todo,branchlength);
			var sum2:Number=calculatesum(array2,todo,branchlength);
			
			if(sum1>=sum2){
				return 1;				
			}else{
				return 0;
			}
			
			return 1;
		}
		
		private function anotherFill(arr:Array,len:int,subsetTest:Array):void
		{
			var quality:int=0;
			var qVect:Array=new Array
			for(var i:uint=0;i<=len;i++){
				for(var j:uint=i;j<=len;j++){
					for(var k:uint=j;k<=len;k++){
						
						for(var index:uint=1; index<=len; index++){
							quality = 1300;
							if(index<=i ){
								quality = 1300;
							}else if(index<=j ){
								quality = 850;
							}else if(index<=k ){
								quality = 500;
							}else{
								quality = 250;
							}
							qVect.push(quality)
						}
						subsetTest.push(qVect);
						qVect=new Array;
					}
				}
			}
		}
		
		private function willWehaveOFF():Object
		{
			//			return false;
			if(reach_max_in==0)
				return null;
			if((netStream1.time+reach_max_in)<(90)) // removing effect of triboolean
				return true;
			return false;
		}
		
		public function setBuffer(Buf:Number,Stream:int):void
		{
			if(Stream==0){
				//				if(Buf-Buffer_0>=30)
				//					logger.debug("asdasd");
				Buffer_0=Buf;
			}else if(Stream==1){
				//				if(Buf-Buffer_1>=30)
				//					logger.debug("asdasd");
				Buffer_1=Buf;
			}else if(Stream==2){
				//				if(Buf-Buffer_2>=30)
				//					logger.debug("asdasd");
				Buffer_2=Buf;
			}else if(Stream==3){
				//				if(Buf-Buffer_3>=30)
				//					logger.debug("asdasd");
				Buffer_3=Buf;
			}else if(Stream==4){
				//				if(Buf-Buffer_4>=30)
				//					logger.debug("asdasd");
				Buffer_4=Buf;
			}else if(Stream==5){
				//				if(Buf-Buffer_5>=30)
				//					logger.debug("asdasd");
				Buffer_5=Buf;
			}else if(Stream==6){
				//				if(Buf-Buffer_6>=30)
				//					logger.debug("asdasd");
				Buffer_6=Buf;
			}
		}
		
		public function setBufferHolder(Buf:Array,Stream:int):void
		{
			if(Stream==0)
				BufferHolder_0=Buf;
			if(Stream==1)
				BufferHolder_1=Buf;
			if(Stream==2)
				BufferHolder_2=Buf;
			if(Stream==3)
				BufferHolder_3=Buf;
			if(Stream==4)
				BufferHolder_4=Buf;
			if(Stream==5)
				BufferHolder_5=Buf;
			if(Stream==6)
				BufferHolder_6=Buf;
		}
		
		private function setavgQ(avg:Number,Stream:int):void
		{
			if(Stream==0)
				avgQ_0=avg;
			if(Stream==1)
				avgQ_1=avg;
			if(Stream==2)
				avgQ_2=avg;
			if(Stream==3)
				avgQ_3=avg;
			if(Stream==4)
				avgQ_4=avg;
			if(Stream==5)
				avgQ_5=avg;
			if(Stream==6)
				avgQ_6=avg;
		}
		
		private function setQHolder(Buf:Array,Stream:int):void
		{
			if(Stream==0)
				QHolder_0=Buf;
			if(Stream==1)
				QHolder_1=Buf;
			if(Stream==2)
				QHolder_2=Buf;
			if(Stream==3)
				QHolder_3=Buf;
			if(Stream==4)
				QHolder_4=Buf;
			if(Stream==5)
				QHolder_5=Buf;
			if(Stream==6)
				QHolder_6=Buf;
		}
		
		
		private function choseQHolder(Stream:int):Array
		{
			if(Stream==0)
				return QHolder_0;
			if(Stream==1)
				return QHolder_1;
			if(Stream==2)
				return QHolder_2;
			if(Stream==3)
				return QHolder_3;
			if(Stream==4)
				return QHolder_4;
			if(Stream==5)
				return QHolder_5;
			if(Stream==6)
				return QHolder_6;
			
			return QHolder_0;
		}
		
		public function choseBufferHolder(Stream:int):Array
		{
			if(Stream==0)
				return BufferHolder_0;
			if(Stream==1)
				return BufferHolder_1;
			if(Stream==2)
				return BufferHolder_2;
			if(Stream==3)
				return BufferHolder_3;
			if(Stream==4)
				return BufferHolder_4;
			if(Stream==5)
				return BufferHolder_5;
			if(Stream==6)
				return BufferHolder_6;
			
			return BufferHolder_0;
		}
		
		public function choseBuffer(Stream:int):Number
		{
			if(Stream==0)
				return Buffer_0;
			if(Stream==1)
				return Buffer_1;
			if(Stream==2)
				return Buffer_2;
			if(Stream==3)
				return Buffer_3;
			if(Stream==4)
				return Buffer_4;
			if(Stream==5)
				return Buffer_5;
			if(Stream==6)
				return Buffer_6;
			
			return Buffer_0;
		}
		
		public function chosequalitylist(Stream:int):Array
		{
			if(Stream==0)
				return qualitylist_0;
			if(Stream==1)
				return qualitylist_1;
			if(Stream==2)
				return qualitylist_2;
			if(Stream==3)
				return qualitylist_3;
			if(Stream==4)
				return qualitylist_4;
			if(Stream==5)
				return qualitylist_5;
			if(Stream==6)
				return qualitylist_6;
			
			return qualitylist_0;
		}
		
		private function setqualitylist(list:Array,Stream:int):void
		{
			if(Stream==0)
				qualitylist_0=list;
			if(Stream==1)
				qualitylist_1=list;
			if(Stream==2)
				qualitylist_2=list;
			if(Stream==3)
				qualitylist_3=list;
			if(Stream==4)
				qualitylist_4=list;
			if(Stream==5)
				qualitylist_5=list;
			if(Stream==6)
				qualitylist_6=list;
		}
		
		private function chosedownloadedlist(Stream:int):Array
		{
			if(Stream==0)
				return downloadedlist_0;
			if(Stream==1)
				return downloadedlist_1;
			if(Stream==2)
				return downloadedlist_2;
			if(Stream==3)
				return downloadedlist_3;
			if(Stream==4)
				return downloadedlist_4;
			if(Stream==5)
				return downloadedlist_5;
			if(Stream==6)
				return downloadedlist_6;
			
			return downloadedlist_0;
		}
		
		private function setdownloadedlist(list:Array,Stream:int):void
		{
			if(Stream==0)
				downloadedlist_0=list;
			if(Stream==1)
				downloadedlist_1=list;
			if(Stream==2)
				downloadedlist_2=list;
			if(Stream==3)
				downloadedlist_3=list;
			if(Stream==4)
				downloadedlist_4=list;
			if(Stream==5)
				downloadedlist_5=list;
			if(Stream==6)
				downloadedlist_6=list;
		}
		
		private function choseFrag():int
		{
			var frag:int=Math.round(getTimetoSeek());
			return Math.round((frag/4)+1);
			
		}
		public function checkandschedule(avg:Number, max:int):void
		{	
			entered=true;
			Buffer=choseBuffer(currentStream);
			off_duration=((Buffer-DesiredMin));
			if(advert==false){
				next_dec=calculate_decisionpoint(netStream1.time);
				if(mode=="multi_bundle")
					next_dec=150;
				triBoolean=willWehaveOFF();
				calculateBranchfrags(next_dec);
				calculateparams();
				switch(BufferStatus)
				{
					case "download":
						ratiocounter=0;
						logger.debug("STATUS "+to_downloadlist.length+" "+downloadBlocker+" "+to_downloadlist); 
						if(to_downloadlist.length == 0 && downloadBlocker==false)//&& balance > 250
						{
							//goes till end
							var numberRemaining:uint = maxinParallel - (numberinParallel-1);
							if((DesiredMin-Buffer)<buf_margin){
								numberRemaining=1;
							}
							var fragment:uint = (streamdownloadedlist[streamdownloadedlist.length-1]+1);
							
							downloadedlist=chosedownloadedlist(currentStream);
							
							if(downloadedlist.indexOf(fragment)>=0)
								fragment = (downloadedlist[downloadedlist.length-1]+1);
							if(lastFrag>fragment)
								fragment=lastFrag+1;
							var file:Array=new Array;
							
							if(mode == "new_enhance"){
								var to_do_alt:Array=new Array;	
								var branch_len:Array=new Array;
								var count:uint=0;
								if(match_array.indexOf(fragment.toString()) >= 0)
									var remaining_frags:int=match_array.length-match_array.indexOf(fragment.toString());
								for(var k:uint=match_array.indexOf(fragment.toString());k<match_array.length;k++){
									to_do_alt.push(match_array[k]);
									count++;
								}
								if(count!=0){
									var remaining_branch:int=(branchArray.length);				
									for(var j:uint=0;j<branchArray.length;j++){
										to_do_alt.push(branchArray[j]);
										branch_len.push(branchArray[j]);
									}
								}
								if(to_do_alt.length>0){
									var subsetTest:Array = [];
									anotherFill(quality_array,to_do_alt.length,subsetTest);
									var purgedarray:Array=subsetTest;
									var possibleArray1:Array=new Array;
									var possibleArray2:Array=new Array;
									
									for(var sub_index:uint=0;sub_index<purgedarray.length;sub_index++){
										var combi:Array=purgedarray[sub_index];

										for(var loop2:uint=1; loop2<=Math.min(2,numberRemaining); loop2++){
											var a1:Number=calculate_bytes(combi,to_do_alt,(avg/loop2));
											var b1:Number=(frag_deadline[match_array[match_array.length-1]]/1000);
											if((netStream1.time+a1) < (b1)){
												if(loop2==1)
													possibleArray1.push(combi);
												if(loop2==2)
													possibleArray2.push(combi);
											}
										}
									}
									
									var index1:int = calculatebest(possibleArray1,to_do_alt,branch_len);
									var index2:int = calculatebest(possibleArray2,to_do_alt,branch_len);
									
									var choice:int=calculatebest_alt(index1,index2,possibleArray1,possibleArray2,to_do_alt,branch_len);
									
									if(choice==1){
										var qual:uint=possibleArray1[index1][0];
										var num:uint=1;
										qSwitcher=false;

									}
									if(choice==0){
										var qual:uint=possibleArray2[index2][0];
										var qual_alt:uint=possibleArray2[index2][1];
										var num:uint=2
										qSwitcher=true;
									}				
									logger.debug("CHOICE "+quali+ " "+num);
								}
							}
							if(mode != "new_enhance" && addeadline=="true"){
								for(var quality:uint=quality_array.length;quality>0;quality--){
									storedtime=0;
									if(quality==4)
										file = sizearray_1300;
									else if(quality==3)
										file = sizearray_850;
									else if(quality==2)
										file = sizearray_500;
									else if(quality==1)
										file = sizearray_250;
									
									//					allow increasing by 1 only
									for(var loop:uint=1; loop<=Math.min(2,numberRemaining); loop++){
										var a:Number=(calcexpectedcompletion(file,((avg)/loop),(fragment+loop-1),loop,quality));
										var b:Number=(frag_deadline[match_array[match_array.length-1]]/1000);

										if(addeadline=="true"){
											if(videoid==0)
												b=20;
											else if(videoid==1)
												b=40;
											else if(videoid==2)
												b=60;
											else if(videoid==3)
												b=80;
											else if(videoid==4)
												b=100;
											else if(videoid==5)
												b=120;
										}
										if((netStream1.time+a) < (b-minus_calc)){
											if((netStream1.time+(calcexpectedcompletion_alt(file[(fragment+loop-1)],avg/loop,(fragment+loop-1)))) < ((frag_deadline[fragment+loop-1]/1000)-minus_calc))	//balance>quality_array[quality-1] 
												//&& ((avg/loop)>quality_array[quality-1])  ***LAST CHANGE 100***
											{
												possibles_connection.push(loop);
												possibles_quality.push(quality)
												logger.debug("result "+netStream1.time+ " "+ (a)+" "+ b+ " "+avg+ " quality "+possibles_quality+ " "+videoid);
											}
										}
									}
								}
							}
							if(mode == "bw_enhance"){
								var index_var:int = enhanceBandwidth(possibles_connection,possibles_quality);
							}
							if(mode == "q_enhance"){
								var index_var:int = enhanceQ(possibles_connection,possibles_quality);
							}
							if(mode != "new_enhance" && addeadline=="false" && mode !="multi_bundle"){
								var num:uint = possibles_connection[index_var];
								var qual:uint = quality_array[possibles_quality[index_var]-1];
								possibles_connection=new Array;
								possibles_quality=new Array;
							}
							if(mode == "ad_video" && addeadline=="false"){
								num=1;
								qual=chosequality(avg,fragment);
							}
							if(mode == "ad_video" && addeadline=="true"){
								num=1;
								qual=quality_array[possibles_quality[0]-1];
								if(qual==0){
									qual=250;
								}

								if(b==20)
									next_dec=6;
								else if(b==40)
									next_dec=11;
								else if(b==60)
									next_dec=16;
								else if(b==80)
									next_dec=21;
								else if(b==100)
									next_dec=26;
								else if(b==120)
									next_dec=31;
							}
							
							if(mode=="multi_bundle"){
								num=1;
								qual=chosequality(bMain,fragment);
							}
							
							logger.debug("decision "+ num + " "+ qual+ " "+fragment + " "+bMain+ " "+numberinParallel);
							if(num==0 && (match_array.indexOf((fragment+1).toString()) < 0))
								num=1;					
							if(num!=0)
							{
								for(var i:uint=0;i<num;i++){
									if(qual==0)
										qual=250;
									if(qSwitcher==true && i>1)
										qual=qual_alt;
									//									THIS WILL DOWNLOAD CURRENT STUFF
									logger.debug("STATUS1 "+fragment+i+" "+next_dec);
									if(next_dec >= ((fragment+i)) || DesiredMin==100)
									{
										var holding:uint = Math.round(netStream1.time/4);
										{
											if(fragmentQ[(fragment+i)] == null){
												to_downloadlist.push((fragment+i));
												to_qualitylist.push(qual);
												if(streamdownloadedlist.indexOf((fragment+i))<0)
													streamdownloadedlist.push((fragment+i))
											}
											else if(fragmentQ[(fragment+i)] != null && checkfirstlandpoint(fragment+i+1)!= true){
												logger.debug("this ran")
												to_downloadlist.push((fragment+i+1));
												to_qualitylist.push(qual);
												if(streamdownloadedlist.indexOf((fragment+i))<0)
													streamdownloadedlist.push((fragment+i))
											}
											blocker = true; 
										}
										logger.debug("STATUS2 "+to_downloadlist);
									}
									branch_prefetchPath = compareFragExtrapolate();
									//									WONT RUN
									if(next_dec < (fragment+i) && stream_downloaded < branch_prefetchPath[0] && addeadline=="false"){
										if(branch_prefetchPathShifted.length > 0 && (branch_prefetchPathShifted.length == branch_prefetchPath.length))
											branch_prefetchPath = branch_prefetchPathShifted;
										{
											for(var x:uint=0; x<branch_prefetchPath.length;x++){
												if(isNaN(branch_prefetchPath[x]))
													branch_prefetchPath.splice(x,1);
											}
										}
										var quali:uint = calculate_prefetch_quality(qual,branch_prefetchPath[0]);
										logger.debug("Distance returned "+ quali + "frag "+branch_prefetchPath[0]);
										if(quali != 0){
											qual = quali;
										}							
										for(var index:uint=0;index<Math.min(2,numberRemaining);index++){
											//						for(var index:uint=0;index<1;index++){
											to_move++;
											if(fragmentQ[branch_prefetchPath[index]] == null){
												to_downloadlist.push(((branch_prefetchPath[index])));
												AltprefetchPath.push(branch_prefetchPath[index]);
												//						logger.debug("branch_prefetchpath downloaded "+ branch_prefetchPath+ " "+ next_dec);
												if(fragmentsquality[branch_prefetchPath[index]] != undefined){
													to_qualitylist.push(qual);
													fragmentsquality[branch_prefetchPath[index]] = qual/1000;
												}
												if(fragmentsquality[branch_prefetchPath[index]] == undefined){
													var whichq1:Number = checkparallelquality();
													to_qualitylist.push(qual);
													fragmentsquality[branch_prefetchPath[index]] = qual/1000;
												}
											}
											branch_prefetchPath[index]=(((branch_prefetchPath[index])+1));
											
										}
										if(branch_prefetchPath.length >1){
											for(var m:uint=0;m<to_move;m++){
												var hold:Number = branch_prefetchPath.shift();
												branch_prefetchPath.push(hold);
												branch_prefetchPathShifted=branch_prefetchPath;
											}
											to_move=0;
										}
									}	
									//									WONT RUN
									if(addeadline=="true"){
										logger.debug("CHECKING 1 "+ (fragment+i)+ " "+stream_downloaded);
										if(((fragment+i)-stream_downloaded)>1){
											deadprefetchunblock=true;
										}else{
											deadprefetchunblock=false;
										}
									}								
									if(((next_dec) < (downloadedlist[downloadedlist.length-1]+1) && addeadline=="true" && pref_array.length!=0 && deadprefetchunblock==true) || (completedONEvideoid.indexOf(videoid)>=0 && completedvideoid.indexOf(videoid)<0))
									{
										logger.debug("CHECKING "+(next_dec)+" "+ (downloadedlist[downloadedlist.length-1]+1)+ " "+(fragment+i)+ " "+pref_array.length+ " "+ deadprefetchunblock+ " "+netstream_buffer);
										if(adparallel_pending==true && adpipe_on==false){
											for(var adm1:uint=0;adm1<admissed_fragments.length;adm1++){
												var adw1:uint=admissed_fragments.shift();
												var adc1:Number=admissed_quality.shift();
												var adi1:int=admissed_id.shift();
												ad_pipe(adw1,adc1,adi1,111);
												if(admissed_fragments.length==0){
													adparallel_pending=false;
												}
											}
										}
										else if(adparallel_pending==false && adpipe_on==false && pref_array.length!=0){
											var id:Number=videoid;									
											var qu:Number=250;
											if(prefetchpolicy=="adaptive"){
												qu=qualitychoice1();
											}
											if(completedvideoid.indexOf(id)<0){
												var fr:Number=pref_array.shift();
												ad_pipe(fr,qu,id,999);
												completedONEvideoid.push(id);
												if((downloadedlist[downloadedlist.length-1]==6 || downloadedlist[downloadedlist.length-1]==11 || downloadedlist[downloadedlist.length-1]==16 || downloadedlist[downloadedlist.length-1]==21 || downloadedlist[downloadedlist.length-1]==26) && pref_array.length==0){
													videoid++;
													pref_array=[1,2];
													completedvideoid.push(id);
												}
											}
										}
									}else if(deadprefetchunblock==false && mode!="multi_bundle"){
										to_downloadlist.push(fragment+i);
										to_qualitylist.push(qual)
									}
								}
								//								WILL RUN
								logger.debug("STATUS3 "+parallel_pending);
								if(missingStuff.length>0 && qual!=0){
									for(var y:int=0;y<missingStuff.length;y++){
										var w:uint=missingStuff.splice(y,1);
										var c:Number=qual;
										parallel_pipe(w,c,currentStream,"download_missingStuff");
										//										lastFrag=w;
										break;
									}
									//									break;
								}else if(parallel_pending==true){
									for(var m:uint=0;m<missed_fragments.length;m++){
										var w:uint=missed_fragments.splice(m,1);
										var c:Number=missed_quality.splice(m,1);
										lastFrag=w;
										parallel_pipe(w,c,currentStream,"download_missed");
										if(missed_fragments.length==0)
											parallel_pending=false;
									}
								}else{
									for(var k1:uint=0;k1<to_downloadlist.length;k1++){
										if(streamwaiting_index.length!=0 && magicunblocker==true){
											//											parallel_pipe((to_downloadlist[k]+1),to_qualitylist[k]);
											var hold1:int=streamwaiting_index.splice(0,1);
											var hold2:int=streamwaiting_quality.splice(0,1);
											parallel_pipe(hold1,hold2,currentStream,"download_regular1");
											lastFrag=hold1;
											prefetchStream=currentStream;
											logger.debug("Downloading these: spliced values");
											magicunblocker=false;
											downloadedlist.push(hold1);
											break;
										}										
										else if(downloadedlist.length==0){
											parallel_pipe((to_downloadlist[k1]),to_qualitylist[k1],currentStream,"download_regular2");
											lastFrag=to_downloadlist[k1];
											prefetchStream=currentStream;
											logger.debug("Downloading these: "+to_downloadlist[k1]+" "+to_qualitylist[k1]+ " "+currentStream);
										}
										else if(downloadedlist.length>0 && to_downloadlist[k1]-downloadedlist[downloadedlist.length-1]==1){
											parallel_pipe((to_downloadlist[k1]),to_qualitylist[k1],currentStream,"download_regular3");
											logger.debug("download_regular_3 "+missingStuff.length+" "+qual);
											lastFrag=to_downloadlist[k1];
											prefetchStream=currentStream;
											logger.debug("Downloading these: "+to_downloadlist[k1]+" "+to_qualitylist[k1]+ " "+currentStream);
										}
									}
								}
								to_downloadlist = new Array;
								to_qualitylist = new Array;
								possibles_connection=new Array;
								possibles_quality=new Array;
								logger.debug("prefetch until here "+branch_prefetchPath);
							}
							
							if(Buffer>DesiredMax && whatbased=="opp" && prefetching=="true" && addeadline=="false"){
								setState("oppwait");
								logger.debug("buffer size 1 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
								break;
							}
							if(tokenNum.length>0 && Buffer>(DesiredMin+(2000/global_avg))&& whatbased=="token" && prefetching=="true"&& addeadline=="false"){
								setState("wait");
								logger.debug("buffer size 2 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
								break;
							}
							if(tokenId.length==0 && Buffer>DesiredMax && whatbased=="token" && prefetching=="true"&& addeadline=="false"){
								setState("wastepreventer");
								logger.debug("buffer size 3 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
								break;
							}
							if(Buffer > DesiredMax && prefetching=="false" && addeadline=="false" && mode!="multi_bundle"){
								setState("noprefwait");
								logger.debug("buffer size 4 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
								break;
							}
							if(Buffer > DesiredMax && addeadline=="true"){  //*****  && (downloadedlist[downloadedlist.length-1]%5)!=0  THIS WILL AVOID WAIT STATE WHEN 1-5 have noT BEEN DOWNLOADED ***
								var remaining:int=Buffer-DesiredMin;
								setState("deadwait");
							}
							Buffer=choseBuffer(currentStream);
							if(mode=="multi_bundle" && Buffer>tmin_bundle && Buffer<tmax_bundle){
								logger.debug("BUFFER SIZE IS "+Buffer+" "+currentStream+" "+BufferStatus+" g_tmin_l_tmax_bundle");
								setCprime("g_tmin_l_tmax_bundle");
								setState("roundrobin_bundle");
							}else if(mode=="multi_bundle" && Buffer<tmin_bundle){
								logger.debug("BUFFER SIZE IS "+Buffer+" "+currentStream+" "+BufferStatus+" le_tmin_bundle");
								setCprime("le_tmin_bundle");
								setState("download");
							}else if(mode=="multi_bundle" && Buffer>tmax_bundle){
								logger.debug("BUFFER SIZE IS "+Buffer+" "+currentStream+" "+BufferStatus+" ge_tmax_bundle");
								setCprime("ge_tmax_bundle");
								setState("roundrobin_bundle");
							}
						}
						break;
					
					case "roundrobin_bundle":
						Buffer=choseBuffer(currentStream);
						if(missingStuff.length!=0 && qual!=0){
							for(var yy:int=0;yy<missingStuff.length;yy++){
								var ww:uint=missingStuff.splice(yy,1);
								var cc:Number=qual;
								parallel_pipe(ww,cc,currentStream,"download_missingStuff");
								break;
							}
						}else if(Buffer<tmin_bundle || streamdownloadedlist[streamdownloadedlist.length-1] > lastFrag){
							setCprime("le_tmin_bundle");
							setState("download");
							logger.debug("BUFFER SIZE IS "+Buffer+" "+currentStream+" "+BufferStatus+" RRB");
							break;
						}else{
							if(downloadBlocker==false){
								if(missingStuff.length!=0){ // && qual!=0
									qual=chosequality(bMain,fragment);
									for(var yy1:int=0;yy1<missingStuff.length;yy1++){
										var ww1:uint=missingStuff.splice(yy1,1);
										var cc1:Number=qual;
										parallel_pipe(ww1,cc1,currentStream,"download_missingStuff");
										break;
									}
								}
								
								prefdownloadedlist=chosedownloadedlist(prefetchStream);
								off_duration=((Buffer-tmin_bundle));
								if(parallel_pending==true && ttd((missed_quality[0]*1.5))<off_duration && parallelpipe_on==false){
									for(var adm:uint=0;adm<missed_fragments.length;adm++){
										var adw:uint=missed_fragments.splice(adm,1);
										var adc:Number=missed_quality.splice(adm,1);
										var ads:Number=missed_stream.splice(adm,1);
										{
											parallel_pipe(adw,adc,ads,"prefetch_missed");
										}
										if(admissed_fragments.length==0){
											parallel_pending=false;
										}
									}
								}
								else if(parallel_pending==false){//&& prefetchpolicy=="lowest"
									//DOWNLOAD AD fragments in off period
									if(bPrefetch<250){
										setState("download");
										break;
									}									
									var switchCatch:Boolean=false;
									var switchCatch1:Boolean=false;
									var actualstream:int=0;
									var saveMainFrag:int=0;
									if(modicaPrefetchica=="equal" || "zipf" || "new_half"){
										if(prefetchStream>6){
											prefetchStream=0;
										}
										var qchoice:Number=0;
										//									NEED TO RUN PORTED QUALITY CHOICE HERE
										portedQuality(bPrefetch);
										BufferHolder=choseBufferHolder(currentStream);
										
										if(prefetchStream==currentStream && BufferHolder.indexOf(lastFrag)>=0){	// SHOULD NOT DO THIS IF LE TMAX IN MY OPINION
											prefetchStream++;
											if(prefetchStream>6){
												prefetchStream=0;
												logger.debug("verify log 1 ran "+lastFrag);
											}
										}
										if(prefetchStream==currentStream && BufferHolder.indexOf(lastFrag)<0){
											switchCatch=true;
											switchCatch1=true;
											actualstream=prefetchStream;
											prefetchStream=currentStream;
											qchoice=chosequality(bMain,fragment);
											saveMainFrag=lastFrag;
											lastFrag=BufferHolder[BufferHolder.length-1]+1;
											logger.debug("verify log 2 ran "+lastFrag);
										}logger.debug("out 2121 "+prefetchStream+" "+lastFrag);
										if(prefetchStream!=currentStream)
											qchoice=chosefromport(positions.indexOf(prefetchStream));
										//
										//									Attempt to force inorder prefetching.
										if(prefetchStream!=currentStream && switchCatch==false){
											var saveLastfrag:int=0;
											var holder:Array=choseBufferHolder(prefetchStream);
											var r:int=holder.length-1;
											var tempus:int=Math.floor(getTimetoSeek()/4);
											var hole:int=fillprefholes(tempus, holder, prefetchStream);
											if(tempus<holder[r] ){	//&& holder[r]+1 < lastFrag
												saveLastfrag=lastFrag;
												lastFrag=holder[r]+1;
												logger.debug("verify log 3 ran changed "+saveLastfrag+" to "+lastFrag+" "+tempus+" "+currentStream+" "+prefetchStream+" hole "+hole);
											}
										}
										
										if(qchoice==0 && prefetchStream!=currentStream){
											switchCatch=true;
											switchCatch1=true;
											actualstream=prefetchStream;
											prefetchStream=currentStream;
											qchoice=chosequality(bMain,fragment);
											BufferHolder=choseBufferHolder(currentStream);
											saveMainFrag=lastFrag;
											lastFrag=BufferHolder[BufferHolder.length-1]+1;
											logger.debug("verify log 4 ran "+lastFrag+" "+currentStream);
										}
										if(qchoice==0){
											break;
										}
										if((ttd((qchoice*1.5))<off_duration)){ 
											//										used thus far..uses downloader count to prefetch...
											if(to_downloadlist.indexOf(lastFrag)<0){
												to_downloadlist.push(lastFrag);
											}
											logger.debug("chosing this frag "+to_downloadlist[to_downloadlist.length-1]+" "+lastFrag+" "+getTimetoSeek()+" "+currentStream+" "+prefetchStream);
											parallel_pipe(to_downloadlist.splice([to_downloadlist.length-1],[to_downloadlist.length]),qchoice,prefetchStream,"prefetch_regular_a");
											if(saveLastfrag!=0){
												lastFrag=saveLastfrag;
											}
											if(parallel_pending==false && prefetchStream!=currentStream)
												setratiocounter(qchoice);
											if(switchCatch==true){
												prefetchStream=actualstream;
												switchCatch=false;
											}
											if(switchCatch1==true){
												lastFrag=saveMainFrag;
												switchCatch1=false;
											}
											prefetchStream++;

											BufferHolder=choseBufferHolder(prefetchStream);
											if(currentStream==prefetchStream && BufferHolder.indexOf(lastFrag)>0){
												lastFrag++;
												logger.debug("verify log 5 ran "+lastFrag);
											}
											checkRatio();
										}										
										else{
											setState("download");
											logger.debug("RRB1");
											break;
										}
									}
								}
								break;
							}												
							break;
						}
						
					case "deadwait":
						if(Buffer < (DesiredMin)){
							setState("download");
							break;
						}
						off_duration=(Buffer-DesiredMin);
						logger.debug("REMAINING "+off_duration);
						//						Do I need pref_array==0 as well?
						if(adpipe_on==false && parallelpipe_on==false && alt_array.length!=0 && adparallel_pending==false && parallel_pending==false){
							var idx:Number=dummyid;									
							var qux:Number=250;
							if(prefetchpolicy=="adaptive"){
								qux=decideq_alt(off_duration);
							}
							if(ttd(qux)<off_duration){
								var frx:Number=alt_array.shift();
								ad_pipe(frx,qux,idx,888);
								if(alt_array.length==0 && dummyid<8 && adparallel_pending==false && parallel_pending==false){
									dummyid++;
									alt_array=[3,4];
								}
							}
							setState("download");
							break;
						}else{
							setState("download");
							break;
						}						
						if(Buffer < (DesiredMin)){
							setState("download");
							break;
						}
						break;
					
					case "oppwait":
						//					{
						if(Buffer < (DesiredMin)){
							setState("download");
							logger.debug("buffer size 12 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
							break;
						}
						if(downloadBlocker==false){
							off_duration=((Buffer-DesiredMin));
							if(adparallel_pending==true && ttd((admissed_quality[0]*1.5))<off_duration && parallelpipe_on==false && advert==false){
								for(var adm:uint=0;adm<admissed_fragments.length;adm++){
									var adw:uint=admissed_fragments.splice(adm,1);
									var adc:Number=admissed_quality.splice(adm,1);
									if(prefetchmode=="serial"){
										ad_pipe_opp(adw,adc);
									}
									if(prefetchmode=="parallel"){
										ad_pipe_parallel(adw,adc);
									}
									if(admissed_fragments.length==0){
										adparallel_pending=false;
									}
								}
							}
							else if(triBoolean==true && willplayAD==true && ad_downloadlist.length<=2 && adID<16 && adparallel_pending==false&&prefetchmode=="serial" && prefetchpolicy=="lowest"){
								//DOWNLOAD AD fragments in off period
								var qchoice:Number=0;
								if((ttd((250*1.5))<off_duration) && onetwocomplete==false){
									qchoice=250;
									if(ad_downloadlist.length==0){
										ad_downloadlist.push(1);
										qchoice=250;
									}
									else if(ad_downloadlist.length!=0 && ad_downloadlist.length<2){
										ad_downloadlist.push(ad_downloadlist[ad_downloadlist.length-1]+1);
									}
									qchoice=250;
									ad_pipe_opp(ad_downloadlist[ad_downloadlist.length-1],qchoice);
								}
								else if((ttd((250*1.5))<off_duration) && onetwocomplete==true){
									qchoice=250;
									if(ad_downloadlist.length==0){
										ad_downloadlist.push(3);
										qchoice=250;
									}
									else if(ad_downloadlist.length!=0 && ad_downloadlist.length<2){
										ad_downloadlist.push(ad_downloadlist[ad_downloadlist.length-1]+1);
									}
									qchoice=250;
									ad_pipe_opp(ad_downloadlist[ad_downloadlist.length-1],qchoice);
								}
								else{
									setState("download");
									logger.debug("buffer size 5 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
									break;
								}
								if(Buffer < (DesiredMin)){//&& adpipe_parallel_on==false
									setState("download");
									logger.debug("buffer size x "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
									break;
								}
								break;
							}
							else if(triBoolean==true && willplayAD==true && ad_downloadlist.length<=2 && adID<16 && adparallel_pending==false&&prefetchmode=="serial" && prefetchpolicy=="adaptive"){
								//DOWNLOAD AD fragments in off period
								var qchoice:Number=0;
								if(global_avg>=1300 && (ttd((1300*1.5))<off_duration) && onetwocomplete==false){
									qchoice=1300;
									if(ad_downloadlist.length==0){
										ad_downloadlist.push(1);
										//									qchoice=250;
									}
									else if(ad_downloadlist.length!=0 && ad_downloadlist.length<2){
										ad_downloadlist.push(ad_downloadlist[ad_downloadlist.length-1]+1);
									}
									ad_pipe_opp(ad_downloadlist[ad_downloadlist.length-1],qchoice);
								}
								else if(global_avg>=850 && (ttd((850*1.5))<off_duration)&& onetwocomplete==false){
									qchoice=850;
									if(ad_downloadlist.length==0){
										ad_downloadlist.push(1);
										//									qchoice=250;
									}
									else if(ad_downloadlist.length!=0 && ad_downloadlist.length<2){
										ad_downloadlist.push(ad_downloadlist[ad_downloadlist.length-1]+1);
									}
									ad_pipe_opp(ad_downloadlist[ad_downloadlist.length-1],qchoice);
								}
								else if(global_avg>=500 && (ttd((500*1.5))<off_duration)&& onetwocomplete==false){
									qchoice=500;
									if(ad_downloadlist.length==0){
										ad_downloadlist.push(1);
										//									qchoice=250;
									}
									else if(ad_downloadlist.length!=0 && ad_downloadlist.length<2){
										ad_downloadlist.push(ad_downloadlist[ad_downloadlist.length-1]+1);
									}

									ad_pipe_opp(ad_downloadlist[ad_downloadlist.length-1],qchoice);
									
								}
								else if((ttd((250*1.5))<off_duration)&& onetwocomplete==false){
									qchoice=250;
									if(ad_downloadlist.length==0){
										ad_downloadlist.push(1);
										qchoice=250;
									}
									else if(ad_downloadlist.length!=0 && ad_downloadlist.length<2){
										ad_downloadlist.push(ad_downloadlist[ad_downloadlist.length-1]+1);
									}
									qchoice=250;
									ad_pipe_opp(ad_downloadlist[ad_downloadlist.length-1],qchoice);
								}
								if(global_avg>=1300 && (ttd((1300*1.5))<off_duration) && onetwocomplete==true){
									qchoice=1300;
									if(ad_downloadlist.length==0){
										ad_downloadlist.push(3);
										//									qchoice=250;
									}
									else if(ad_downloadlist.length!=0 && ad_downloadlist.length<2){
										ad_downloadlist.push(ad_downloadlist[ad_downloadlist.length-1]+1);
									}
									ad_pipe_opp(ad_downloadlist[ad_downloadlist.length-1],qchoice);
								}
								else if(global_avg>=850 && (ttd((850*1.5))<off_duration)&& onetwocomplete==true){
									qchoice=850;
									if(ad_downloadlist.length==0){
										ad_downloadlist.push(3);
										//									qchoice=250;
									}
									else if(ad_downloadlist.length!=0 && ad_downloadlist.length<2){
										ad_downloadlist.push(ad_downloadlist[ad_downloadlist.length-1]+1);
									}
									ad_pipe_opp(ad_downloadlist[ad_downloadlist.length-1],qchoice);
								}
								else if(global_avg>=500 && (ttd((500*1.5))<off_duration)&& onetwocomplete==true){
									qchoice=500;
									if(ad_downloadlist.length==0){
										ad_downloadlist.push(3);
										//									qchoice=250;
									}
									else if(ad_downloadlist.length!=0 && ad_downloadlist.length<2){
										ad_downloadlist.push(ad_downloadlist[ad_downloadlist.length-1]+1);
									}
									ad_pipe_opp(ad_downloadlist[ad_downloadlist.length-1],qchoice);
									
								}
								else if((ttd((250*1.5))<off_duration)&& onetwocomplete==true){
									qchoice=250;
									if(ad_downloadlist.length==0){
										ad_downloadlist.push(3);
										qchoice=250;
									}
									else if(ad_downloadlist.length!=0 && ad_downloadlist.length<2){
										ad_downloadlist.push(ad_downloadlist[ad_downloadlist.length-1]+1);
									}
									qchoice=250;
									ad_pipe_opp(ad_downloadlist[ad_downloadlist.length-1],qchoice);
								}
							}else{
								setState("download");
								logger.debug("buffer size 17 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
								break;
							}
							if(Buffer < (DesiredMin)){//&& adpipe_parallel_on==false
								
							}
							else if(DesiredMin==0){
								setState("download");
								logger.debug("buffer size 8 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
								break;
							}
							break;
						}
						//					}
					case "wait":
						logger.debug("print out out "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus+ " "+ triBoolean + " "+ willplayAD + " "+ adparallel_pending + " "+ parallelpipe_on + " "+ advert + " "+ tokenNum.length);
						off_duration=((Buffer-DesiredMin));
						if(triBoolean==true && willplayAD==true && adparallel_pending==true && parallelpipe_on==false && advert==false){ // && ttd((admissed_quality[0]*1.5))<off_duration
							logger.debug("print out missed "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus+ " "+ triBoolean + " "+ willplayAD + " "+ adparallel_pending + " "+ parallelpipe_on + " "+ advert + " "+ tokenNum.length);
							for(var adm1:uint=0;adm1<admissed_fragments.length;adm1++){
								var adw1:uint=admissed_fragments.splice(adm1,1);
								var adc1:Number=admissed_quality.splice(adm1,1);
								var adi1:int=admissed_id.splice(adm1,1);
								if(prefetchmode=="serial"){
									ad_pipe(adw1,adc1,adi1,222);
									logger.debug("Queued stuff "+ adw1+ " "+ adc1);
								}
								if(prefetchmode=="parallel"){
									ad_pipe_parallel(adw1,adc1);
								}
								if(admissed_fragments.length==0){
									adparallel_pending=false;
								}
							}
						}
						else if(triBoolean==true && willplayAD==true && adparallel_pending==false&&prefetchmode=="serial" && parallelpipe_on==false && advert==false){
							//DOWNLOAD AD fragments in off period
							logger.debug("print out regular "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus+ " "+ triBoolean + " "+ willplayAD + " "+ adparallel_pending + " "+ parallelpipe_on + " "+ advert + " "+ tokenNum.length);
							if(tokenNum.length>0 && BufferStatus=="wait"){
								tokenQ.push(qualitychoice(off_duration));
								//								if(ttd(tokenQ[0]*1.5)<(off_duration)){
								downloadedtokenNum.push(tokenNum[0]);
								downloadedtokenId.push(tokenId[0]);
								ad_pipe(tokenNum.shift(),tokenQ.shift(),tokenId.shift(),333);
								//								}
							}
							else if(tokenId.length==0 && Buffer>DesiredMax){
								setState("wastepreventer");
								logger.debug("buffer size x11 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus+ " "+ triBoolean + " "+ willplayAD + " "+ adparallel_pending + " "+ parallelpipe_on + " "+ advert + " "+ tokenNum.length);
								break;
							}else{
								setState("download");
							}
						}
						if(Buffer < (DesiredMin)){
							setState("download");
							logger.debug("buffer size x12 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
							break;
						}
						else if(DesiredMin==0){
							setState("download");
							logger.debug("buffer size 13 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
							break;
						}
						break;
					//					}
					case "wastepreventer":
						if(Buffer < (DesiredMin)){
							setState("download");
							logger.debug("buffer size 12 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
							break;
						}
						if(downloadBlocker==false){
							off_duration=((Buffer-DesiredMin));
							if(adparallel_pending==true && parallelpipe_on==false && advert==false && ttd((admissed_quality[0]*1.5))<off_duration){
								for(var adm2:uint=0;adm2<admissed_fragments.length;adm2++){
									var adw2:uint=admissed_fragments.splice(adm2,1);
									var adc2:Number=admissed_quality.splice(adm2,1);
									var adi2:int=admissed_id.splice(adm2,1);
									if(prefetchmode=="serial"){
										ad_pipe(adw2,adc2,adi2,444);
									}
									if(prefetchmode=="parallel"){
										ad_pipe_parallel(adw2,adc2);
									}
									if(admissed_fragments.length==0){
										adparallel_pending=false;
									}
								}
							}
							else if(parallelpipe_on==false && adparallel_pending==false && advert==false){
								var indexer:int=Math.floor(timePass/20);		
								for(var h:uint=0;h<1;h++){
									if(alternatetokenId[h]>=indexer && filler=="true"){
										var temp:int=(alternatetokenId.splice(h,1));
										var temp1:int=(alternatetokenNum.splice(h,1));
										preventertokenId.push(temp);
										preventertokenNum.push(temp1);
										preventertokenQ.push(1300);
									}
									if(checkcondition()==true && advert==false && preventertokenNum.length!=0 && filler=="true"){
										if(preventertokenNum.length>0 && ttd(preventertokenQ[0]*1.5)<(off_duration)&& BufferStatus=="wastepreventer"){
											ad_pipe(preventertokenNum.shift(),preventertokenQ.shift(),preventertokenId.shift(),555);
										}
									}else if(filler=="true" && previouslyLogged!="wait"){
										setState("wait");
										logger.debug("buffer size 9 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
										break;
									}
									if(Buffer < (DesiredMin)){//&& adpipe_parallel_on==false
										setState("download");
										logger.debug("buffer size "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
										break;
									}
								}
								if(orderedlist.length>0 && global_avg!=0 && filler=="false"){
									var holding1:String=((orderedlist.pop()));
									preventertokenNum.push(transforminputs(holding1,2));
									preventertokenId.push(transforminputs(holding1,1));
									preventertokenQ.push(qualitychoice(off_duration));
								}

								if(advert==false && preventertokenNum.length!=0 && filler=="false"){
									if(preventertokenNum.length>0 && ttd(preventertokenQ[0]*1.5)<(off_duration)&& BufferStatus=="wastepreventer"){
										ad_pipe(preventertokenNum.shift(),preventertokenQ.shift(),preventertokenId.shift(),666);
									}
								}else if(filler=="false" && previouslyLogged!="wait"){
									setState("wait");
									logger.debug("buffer size 9 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
									break;
								}else{
									setState("download");
									logger.debug("buffer size x11 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
									break;
								}
								
								if(Buffer < (DesiredMin)){//&& adpipe_parallel_on==false
									setState("download");
									logger.debug("buffer size x "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
									break;
								}
							}
						}
						break;
					
					case "noprefwait":
						if(Buffer < (DesiredMin)){
							setState("download");
							logger.debug("buffer size 10 "+Buffer+ " "+DesiredMax+ " "+DesiredMin+ " "+BufferStatus);
							break;
						}
						break;				
				}
			}
		}
		
		private function returnhole(playtime:Number,chunktime:int, bhold:Array, pstream:int):int
		{
			var value:int=0;
			if(playtime>=30 && playtime<60){
				value=fillprefholes(chunktime,bhold,pstream);
				if(value<Math.floor(30/4)){
					return Math.floor(30/4);
				}
			}else if(playtime>=60 && playtime<90){
				value=fillprefholes(chunktime,bhold,pstream);
				if(value<Math.floor(60/4)){
					return Math.floor(60/4);
				}
			}else if(playtime>=90 && playtime<120){
				value=fillprefholes(chunktime,bhold,pstream);
				if(value<Math.floor(90/4)){
					return Math.floor(90/4);
				}
			}else if(playtime>=120 && playtime<150){
				value=fillprefholes(chunktime,bhold,pstream);
				if(value<Math.floor(120/4)){
					return Math.floor(120/4);
				}
			}else if(playtime>=150 && playtime<180){
				value=fillprefholes(chunktime,bhold,pstream);
				if(value<Math.floor(150/4)){
					return Math.floor(150/4);
				}
			}else if(playtime>=180 && playtime<210){
				value=fillprefholes(chunktime,bhold,pstream);
				if(value<Math.floor(180/4)){
					return Math.floor(180/4);
				}
			}else if(playtime>=210 && playtime<240){
				value=fillprefholes(chunktime,bhold,pstream);
				if(value<Math.floor(210/4)){
					return Math.floor(210/4);
				}
			}else if(playtime>=240 && playtime<270){
				value=fillprefholes(chunktime,bhold,pstream);
				if(value<Math.floor(240/4)){
					return Math.floor(240/4);
				}
			}else if(playtime>=270 && playtime<300){
				value=fillprefholes(chunktime,bhold,pstream);
				if(value<Math.floor(270/4)){
					return Math.floor(270/4);
				}
			}else if(playtime>=300 && playtime<330){
				value=fillprefholes(chunktime,bhold,pstream);
				if(value<Math.floor(300/4)){
					return Math.floor(300/4);
				}
			}
			return 0;
		}
		
		private function fillprefholes(chunk:int, bhold:Array, pstream:int):int
		{
			if(bhold.length>0){
				var temp:Array=new Array;
				bhold.sort(Array.NUMERIC);
				for (var t:int = bhold.length-1; t>0; --t)	//REMOVE DUPLICATES
				{
					if (bhold[t]==bhold[t-1])
					{
						bhold.splice(t,1);
					}
				}
				for(var j:int=0;j<bhold.length-1;j++){
					if(bhold[j]-bhold[j+1]>1){
						return bhold[j]+1;
					}
				}
				return bhold[bhold.length-1]+1;
			}
			return 0;
		}
		
		private function setratiocounter(qual:Number):void
		{
			if(qual==250)
				ratiocounter=ratiocounter+(250/bMain);
			else if(qual==500)
				ratiocounter=ratiocounter+(500/bMain);
			else if(qual==850)
				ratiocounter=ratiocounter+(850/bMain);
			else if(qual==1300)
				ratiocounter=ratiocounter+(1300/bMain);
		}
		
		private function checkRatio():void
		{
			var ratio:int=0;
			Buffer=choseBuffer(currentStream);
			if(Buffer>tmax_bundle)
				ratio=(Math.round(bPrefetch/bMain)+0.5);
			else
				ratio=Math.round(bPrefetch/bMain);
			if(ratio==0)
				setState("download");			
			if(ratiocounter>ratio){
				setState("download");
				logger.debug("RRB12 true "+ratiocounter+" "+ratio+ " "+bPrefetch+" "+bMain);
			}else{
				logger.debug("RRB12 false "+ratiocounter+" "+ratio+ " "+bPrefetch+" "+bMain);
			}
		}
		
		private function setCprime(value:String):void
		{
			var c:Number=0;
			if(value=="g_tmin_l_tmax_bundle"){
				Buffer=choseBuffer(currentStream);
				var x:Number=(Buffer-tmin_bundle)/(tmax_bundle-tmin_bundle);
				c=((1-x)*Math.max(1950,(global_avg/7)))+(x*Math.max(1300,(global_avg/7)));
				if(c>global_avg)
					c=global_avg;
				bMain=c;
				bPrefetch=global_avg-c;
			}
			else if(value=="le_tmin_bundle"){
				c=global_avg;
				bMain=c;
				bPrefetch=global_avg-c;
			}
			else if(value=="ge_tmax_bundle"){
				c=Math.max(1300,global_avg/7);
				bMain=c;
				bPrefetch=global_avg-c;
			}
		}
		
		public function switchInitiated(seektime:Number):void
		{
			missingStuff=new Array;
			logger.debug("Switch initiated from ad manager");
			prefetchStream=currentStream;
			to_downloadlist= new Array;
			to_qualitylist=new Array;
			stream_downloaded=new int;
			var fragIndex:int=Math.round(seektime/4);
			BufferHolder=choseBufferHolder(prefetchStream);
			if(BufferHolder.length>0){
				for(var g:int=0;g<BufferHolder.length;g++){
					//				logger.debug(
					logger.debug("see tis oo "+BufferHolder[g]+" "+fragIndex+" "+currentStream);
				}
				for(var i:int=0;i<BufferHolder.length;i++){
					if(fragIndex>BufferHolder[i]){
						BufferHolder.splice(i,i+1)
						i--;
					}
				}
				BufferHolder.sort(Array.NUMERIC);
				
				for(var h:int=0;h<BufferHolder.length;h++){
					logger.debug("see tis too "+BufferHolder[h]+" "+fragIndex);
				}
				//			
				justSwitched=true;
				for(var uu:int=fragIndex;uu<BufferHolder[0];uu++){
					missingStuff.push(uu);
				}
				for(var q:int=0;q<BufferHolder.length;q++){
					if(q+1<BufferHolder.length){
						if(BufferHolder[q+1]-BufferHolder[q]>1){
							for(var p:int=0;p<(BufferHolder[q+1]-BufferHolder[q]-1);p++){
								missingStuff.push(BufferHolder[q]+p+1);
							}
						}
					}
				}
				
				for(var qa:int=0;qa<missingStuff.length;qa++){
					logger.debug("see tis hoo miss "+missingStuff[qa]+" "+fragIndex);
				}
			}else{
				if(fragIndex>1){
					missingStuff.push(fragIndex);
					missingStuff.push(fragIndex+1);
					missingStuff.push(fragIndex+2);
					missingStuff.push(fragIndex+3);
					missingStuff.push(fragIndex+4);
					logger.debug("see tis adding empty");
				}
			}
			
			setBufferHolder(BufferHolder,prefetchStream);
			recomputeBuffer(fragIndex,prefetchStream);
		}
		
		private function recomputeBuffer(index:int,stream:int):void
		{
			if(index<=1)
				return;
			var buf:Number=0;
			var temp:Array=new Array;
			BufferHolder=choseBufferHolder(stream);
			{
				BufferHolder.sort(Array.NUMERIC);			
				for (var t:int = BufferHolder.length-1; t>0; --t)
				{
					if (BufferHolder[t]==BufferHolder[t-1])
					{
						BufferHolder.splice(t,1);
					}
				}
				temp.push(index);
				for(var j:int=0;j<BufferHolder.length;j++){
					if(BufferHolder[j]-temp[temp.length-1]==1){
						temp.push(BufferHolder[j]);
					}else{
						break;
					}
				}
				if(justSwitched==true){
					for(var qa:int=0;qa<temp.length;qa++){
						logger.debug("hoo final "+temp[qa]);
					}
				}
				justSwitched=false;
			}
			for(var i:int=0;i<temp.length;i++){
				//				Buffer+=4;//add runtimes here...
				buf+=(runtable[temp[i]-1]/1000);
			}
			setBuffer(buf,stream);
			
		}
		
		private function recomputeQ():void
		{
			var sum:int=0;
			var entries:int=0;
			var result:Number=0;
			for(var i:int=0;i<=6;i++){
				QHolder=choseQHolder(i);
				for(var m:int=0;m<QHolder.length;m++){					
					if(QHolder[m]!=0 && QHolder[m]!=null){
						entries++;
						sum=sum+QHolder[m];
					}
				}
				if(entries!=0){
					result=sum/entries;
					setavgQ(result,i);
				}
				sum=0;
				entries=0;
				result=0;
			}
		}
		
		private function decideq(buffer:Number):Number
		{
			var qualityarray:Array=[1300,850,500,250];
			var timearray:Array=new Array;
			var resultarray:Array=new Array;
			var returnvar:int=9;
			for(var i:uint=0;i<qualityarray.length;i++)
			{
				timearray[i]=ttd(qualityarray[i]);
			}
			
			for(var j:uint=0;j<timearray.length;j++)
			{
				resultarray[j]=buffer-timearray[j];
			}
			for (var k:uint=0;k<resultarray.length;k++)
			{
				if(resultarray[k]>=4){
					returnvar=k;
					break;
				}
			}
			if(returnvar==0)
				return 1300;
			if(returnvar==1)
				return 850;
			if(returnvar==2)
				return 500;
			if(returnvar==3)
				return 250;
			return 250;
		}
		
		private function decideq_alt(off_period:Number):Number
		{
			var q:Array=[1300,850,500,250];
			{
				for (var m:uint=0;m<q.length;m++){
					if((global_avg)>q[m] && ttd((q[m]*1.5))<off_period){	
						return q[m];
						break;
					}
				}
			}
			return 250;			
		}
		
		private function checkcondition():Boolean
		{
			for(var i:uint=0;i<downloadedtokenId.length;i++){
				if(downloadedtokenId[i]==preventertokenId[0]){
					if(downloadedtokenNum[i]==2)
						return true;
				}
			}
			return false;
		}
		
		private function transforminputs(numbers:String,modifier:int):int
		{
			var hold:Array=numbers.split(".");
			if(modifier==1)
				return hold[0];
			if(modifier==2)
				return hold[1];
			
			return 0;
		}
		
		
		private function checkbufferstatus():int
		{
			var holding:Number=-1;
			var downloadtimes:Array=new Array;
			var timeleft:Number=Buffer-DesiredMin;
			downloadtimes.push(ttd(250));
			downloadtimes.push(ttd(500));
			downloadtimes.push(ttd(850));
			downloadtimes.push(ttd(1300));		
			
			for(var i:uint=0;i<downloadtimes.length;i++){
				if(downloadtimes[i]<timeleft){
					holding=i;
				}
			}
			return holding;
		}
		
		private function ttd(q:Number):Number
		{
			var time:Number=(q*4)/global_avg;
			return time;
		}
		
		public function setState(value:String):void
		{
			previouslyLogged = BufferStatus;
			BufferStatus = value;
			logger.debug("Setting buffer state "+BufferStatus);
		}
		
		public function checkifDownloaded(frag:int,stream:int):Boolean
		{
			downloadedlist=chosedownloadedlist(stream);
			qualitylist=chosequalitylist(stream);
			if(downloadedlist[frag]!=null){
				if(qualitylist[frag]!=null){
					return true
				}
			}
			return false;
		}
		
		public function getfragq():Dictionary
		{
			return fragmentsquality;
		}
		
		public function calculate_prefetch_quality(chosenq:uint,fragnum:uint):int
		{
			if(fragnum == 0)
				return quality_array[0];
			var distance:uint = calculate_distance_from_landpoint(fragnum);
			var x:Number=0;
					
			if(distance > 0){
				return 1300;
			}
			return 0;
		}
		
		private function calculate_distance_from_landpoint(frag:uint):int
		{
			var holding:Array=new Array;
			for(var i:uint=0;i<landPoints.length;i++){
				if(frag>landPoints[i]){
					holding.push(frag-landPoints[i]);
				}
				if(frag < landPoints[i]){
					//					logger.debug("frag smaller");
				}
				if(frag == landPoints[i]){
					holding.push(0);
				}
				for(var j:uint=0;j<firstlandPoints.length;j++){
					
					if(frag>firstlandPoints[j]){
						holding.push(frag-firstlandPoints[j]);
					}
					if(frag < firstlandPoints[j]){
						//						logger.debug("frag smaller");
					}
					if(frag== firstlandPoints[j]){
						holding.push(0);
					}
				}
			}
			return findMin(holding);
		}
		
		public function calculate_decisionpoint(time:Number):int
		{
			netStream1.setpath(time);
			var match_array:Array = new Array;
			var final_array:Array= new Array;
			var length_array:Array= new Array;
			for(var i:uint=0;i<all_jump_paths.length;i++)
			{
				if(all_jump_paths[i].indexOf(playerpath) >= 0 && all_jump_paths[i] != playerpath){
					match_array.push(all_jump_paths[i]);
					length_array.push(all_jump_paths[i].length);
				}			
			}
			var min_len:int = findMin(length_array);
			
			for(var k:uint=0;k<match_array.length;k++){
				if(match_array[k].length == min_len){
					final_array.push(match_array[k]);
				}
				var branchpoint:int=find_dec(final_array);
			}
			
			//			logger.debug("final path "+final_array+ " "+ playerpath+ " branchpoint "+branchpoint);
			return branchpoint;
		}
		
		private function find_dec(array:Array):int
		{
			var branch_pt:Array = new Array;
			var holding:Array = new Array;
			for(var i:uint=0;i<array.length;i++){
				var hold:Array = array[i].split(" ");
				holding[i]= hold[hold.length-2];
			}
			var min:uint=Number(holding[0]);
			for(var k:uint=0; k< holding.length; k++){
				if(Number(holding[i])<min)
					min=Number(holding[i]);
			}
			return min;
		}
		
		private function findMin(array:Array):Number {
			var min:int= array[0];
			for (var i:uint = 0; i < array.length; i++) {
				if (array[i] < min) {
					min = array[i];
				}
			}
			return min;
		}
		
		public function calc_next_decpoint(frag:uint):int
		{
			for(var i:uint=0;i<decPoints.length;i++){
				if(frag<decPoints[i]){
					return decPoints[i];
					break;
				}
			}
			return decPoints[decPoints.length-1];
		}
		
		public function calcexpectedcompletion(size:Array,esti:Number,frag_num:uint,connxn:uint,q:uint):Number
		{
			var originalsize:Array=size;
			var p_q:uint=0;
			var count:uint=0;
			var to_do:Array=new Array;
			var bytes:int=0;
			if(frag_num<=3)
				esti=esti*(0.5);
			//			if(frag_num>4)
			//				esti=esti*(0.85);
			if(addeadline=="false"){
				if(match_array.indexOf(frag_num.toString()) >= 0)
					var remaining_frags:int=match_array.length-match_array.indexOf(frag_num.toString());
				for(var k:uint=match_array.indexOf(frag_num.toString());k<match_array.length;k++){
					to_do.push(match_array[k]);
					count++;
				}
				if(count!=0){
					var remaining_branch:int=(branchArray.length);
					
					for(var j:uint=0;j<branchArray.length;j++){
						to_do.push(branchArray[j]);
					}
					//			MORE ACCURATE....but faulty for some reason....works
					for(var m:uint=0;m<count;m++){
						bytes = bytes+(size[to_do[m]]);
					}
					
					for(var n:uint=0;n<branchArray.length;n++){
						p_q=calculate_prefetch_quality(q,branchArray[n]);
						if(p_q==250)
							size=sizearray_250;
						if(p_q==500)
							size=sizearray_500;
						if(p_q==850)
							size=sizearray_850;
						if(p_q==1300)
							size=sizearray_1300;
						if(p_q==0)
							size=originalsize;
						bytes = bytes+(size[branchArray[n]]);
					}
					//returns data left in kb
					if(numberinParallel!=0){
						esti=esti/numberinParallel;
					}
					if(normal_running>0){
						esti=(esti-(downloader_rate*1000))
					}
					var tempo:Number=bytes/(esti);
					return tempo;
				}
				return 1000;
			}
			if(addeadline=="true"){
				var match_array_internal:Array=new Array
				var pointer:int=match_array.indexOf(frag_num.toString());
				if(pointer>=20)
					match_array_internal=match_array_alt5;
				else if(pointer>=15)
					match_array_internal=match_array_alt4;
				else if(pointer>=10)
					match_array_internal=match_array_alt3;
				else if(pointer>=5)
					match_array_internal=match_array_alt2;
				else if(pointer>=0)
					match_array_internal=match_array_alt1;
			}
			var pointer_alt:int=match_array_internal.indexOf(frag_num);
			for(var k:uint=pointer_alt;k<match_array_internal.length;k++){
				to_do.push(match_array_internal[k]);
				count++;
			}
			for(var u:uint=0;u<count;u++){
				bytes = bytes+(size[to_do[u]]);
			}
			var prefetchpointer:Number=netStream1.time/20;
			
			if(prefetchpointer<1)
				videoid_alt=0;
			else if(prefetchpointer<2)
				videoid_alt=1;
			else if(prefetchpointer<3)
				videoid_alt=2;
			else if(prefetchpointer<4)
				videoid_alt=3;
			else if(prefetchpointer<5)
				videoid_alt=4;
			else if(prefetchpointer<6)
				videoid_alt=5;
			else if(prefetchpointer<7)
				videoid_alt=6;		
			
			if(videoid_alt>videoid){		
				videoid=videoid_alt;
				pref_array=[1,2];
			}
			
			for(var x:uint=0;x<4;x++){
				bytes = bytes+(size[2]);//to_do[x]
			}
			return bytes/esti;
		}
		
		public function chosequality(bw:Number,frag:int):int
		{
			if(bw > 250 && bw < 500)
				return 250;
			if(bw > 500 && bw < 850)
				return 500;
			if(bw > 850 && bw < 1300)
				return 850;
			if(bw >= 1300)
				return 1300;
			return 250;
		}
		
		public function onCompleteEst_alt(event:Event):void
		{
			dloadTimerendest_alt = gettime();
			parallelpipe_on_alt = false;
			time_download[prefestF1_alt] = (dloadTimerendest_alt-dloadTimerbeginest_alt)/1000;
			quality_download[prefestF1_alt] = prefestQ1_alt;
			numberinParallel--;
			logger.debug("download info "+ time_download[prefestF1_alt]+ " "+ quality_download[prefestF1_alt]+ " "+prefestF1_alt);
			var estimate:Number = (((fragments[prefestF1_alt].bytesAvailable)*8/1000)/((dloadTimerendest_alt-dloadTimerbeginest_alt)/1000));
			
			Buffer+=(runtable[prefestF1_alt-1]/1000);
			if(numberinParallel!=0)
				estimate=estimate*numberinParallel;
			logger.debug("PATTEX Downloaded frag info est 1: " + estimate);
			calculate_avg(estimate,quality_download[prefestF1_alt]);
			if(seeking==false)
				checkandschedule(global_avg,maxinParallel);
		}
		
		public function onCompleteEst_alt1(event:Event):void
		{
			dloadTimerendest_alt1 = gettime();
			parallelpipe_on_alt1 = false;
			time_download[prefestF1_alt1] = (dloadTimerendest_alt1-dloadTimerbeginest_alt1)/1000;
			quality_download[prefestF1_alt1] = prefestQ1_alt1;
			numberinParallel--;
			logger.debug("download info "+ time_download[prefestF1_alt1]+ " "+ quality_download[prefestF1_alt1]+ " "+prefestF1_alt1);
			var estimate:Number = (((fragments[prefestF1_alt1].bytesAvailable)*8/1000)/((dloadTimerendest_alt1-dloadTimerbeginest_alt1)/1000));

			Buffer+=(runtable[prefestF1_alt1-1]/1000);
			if(numberinParallel!=0)
				estimate=estimate*numberinParallel;
			logger.debug("PATTEX Downloaded frag info est 2: " + estimate);
			calculate_avg(estimate,quality_download[prefestF1_alt1]);
			if(seeking==false)
				checkandschedule(global_avg,maxinParallel);
		}
		
		public function onComplete(event:Event):void
		{
			dloadTimerend1 = gettime();
			var urlTemp:URLStream = URLStream(event.target);
			
			logger.debug("PATTEX Downloaded frag info1: " + ((masterSizeList[prefF1][prefQ1])/(dloadTimerend1-dloadTimerbegin1)));
			CONFIG::LOGGING
			{
				numBytes += urlTemp.bytesAvailable;
			}
		}
		private function onComplete1(event:Event):void
		{
			dloadTimerend2 = gettime();
			var urlTemp:URLStream = URLStream(event.target);
			
			logger.debug("PATTEX Downloaded frag info2: " + ((masterSizeList[prefF2][prefQ2])/(dloadTimerend2-dloadTimerbegin2)));
			CONFIG::LOGGING
			{
				numBytes += urlTemp.bytesAvailable;
			}
		}
		public function onComplete2(event:Event):void
		{
			dloadTimerend3 = gettime();	
			var urlTemp:URLStream = URLStream(event.target);
			time_download[prefF3] = (dloadTimerend3-dloadTimerbegin3)/1000;
			quality_download[prefF3] = fragmentsquality[prefF3];
			logger.debug("download info 16 "+ time_download[prefF3]+ " "+ quality_download[prefF3]+ " "+prefF3);
			
			if(time_download[prefF3] < 10){
				
				var estimate:Number = (((fragments[prefF3].bytesAvailable)*8/1000)/((dloadTimerend3-dloadTimerbegin3)/1000));
				//				
				if(parallelpipe_on == true && parallelpipe_on_alt == false)
					estimate = estimate*2;
				if(parallelpipe_on == false && parallelpipe_on_alt == true)
					estimate = estimate*2;
				if(parallelpipe_on == true && parallelpipe_on_alt == true)
					estimate = estimate*3;
				calculate_avg(estimate,quality_download[prefF3]);
			}
			
			CONFIG::LOGGING
			{
				numBytes += urlTemp.bytesAvailable;
			}
		}
		public function onComplete3(event:Event):void
		{
			dloadTimerend4 = gettime();
			var urlTemp:URLStream = URLStream(event.target);
			
			time_download[prefF4] = (dloadTimerend4-dloadTimerbegin4)/1000;
			quality_download[prefF4] = fragmentsquality[prefF4];
			logger.debug("download info 16 "+ time_download[prefF4]+ " "+ quality_download[prefF4]+ " "+prefF4);
			
			if(time_download[prefF4] < 10){
				
				var estimate:Number = (((fragments[prefF4].bytesAvailable)*8/1000)/((dloadTimerend4-dloadTimerbegin4)/1000));
				calculate_avg(estimate,quality_download[prefF4]);
			}
			
			CONFIG::LOGGING
			{
				numBytes += urlTemp.bytesAvailable;
			}
		}
	}
}